const {registerBlockType} = wp.blocks;
const {InspectorControls} = wp.blockEditor;
const {Component} = wp.element;
const {__} = wp.i18n;

import FeatherIcon from '../../components/FeatherIcon';

class BlockEdit extends Component {

  constructor(props) {

    super(...arguments);

  }

  render() {

    return [
      <div className="daextlwcn-block-image" key="daextlwcn-block-image">{__(
          'Delete Cookies', 'lightweight-cookie-notice')}</div>,
    ];

  }

}

/**
 * Register the Gutenberg block
 */
registerBlockType('daextlwcn/delete-cookies', {
  title: __('Delete Cookies', 'lightweight-cookie-notice'),
  icon: FeatherIcon,
  category: 'widgets',
  keywords: [
    __('delete', 'lightweight-cookie-notice'),
    __('cookies', 'lightweight-cookie-notice'),
    __('cookie', 'lightweight-cookie-notice'),
  ],

  /**
   * The edit function describes the structure of your block in the context of the editor.
   * This represents what the editor will render when the block is used.
   *
   * The "edit" property must be a valid function.
   *
   * @link https://wordpress.org/gutenberg/handbook/block-api/block-edit-save/
   */
  edit: BlockEdit,

  /**
   * The save function defines the way in which the different attributes should be combined
   * into the final markup, which is then serialized by Gutenberg into post_content.
   *
   * The "save" property must be specified and must be a valid function.
   *
   * @link https://wordpress.org/gutenberg/handbook/block-api/block-edit-save/
   */
  save: function() {

    /**
     * This is a dynamic block and the rendering is performed with PHP:
     *
     * https://wordpress.org/gutenberg/handbook/blocks/creating-dynamic-blocks/
     */
    return null;

  },

});
