<?php

/**
 * This file includes functions that in order to support the "Page Fragment Cache" feature of W3 Total Cache can't be
 * included in the plugin classes.
 */

/**
 * Prints the scripts associated with the categories when the acceptance state of the category is enabled.
 *
 * @param $in_footer Whether to verify and print the HEAD or the BODY script of the category.
 */
function daextlwcn_print_scripts( $in_footer = false ) {

	if ( ! isset( $_COOKIE['daextlwcn-accepted'] ) or ! isset( $_COOKIE['daextlwcn-category-status'] ) ) {
		return;
	}

	$category_state_a = json_decode( stripslashes( $_COOKIE['daextlwcn-category-status'] ) );

	if ( $in_footer ) {
		$position = 'script_body';
	} else {
		$position = 'script_head';
	}

	global $wpdb;
	$table_name = $wpdb->prefix . 'daextlwcn_category';
	$sql        = "SELECT * FROM $table_name ORDER BY priority ASC";
	$category_a = $wpdb->get_results( $sql, ARRAY_A );

	foreach ( $category_a as $key => $category ) {

		if ( strlen( trim( $category[ $position ] ) ) > 0 ) {

			//Print the script only if this category state is enabled
			foreach ( $category_state_a as $key => $single_category_state ) {
				if ( $category['category_id'] == $single_category_state->categoryId and
				     $single_category_state->status == '1' ) {
					echo stripslashes( $category[ $position ] );
				}
			}

		}

	}

}

/**
 * Echo a function that includes the scripts associated with all the categories. These scripts are executed with
 * JavaScript when the user clicks a button associated with an "Accept Cookies" action, and the related category is
 * enabled.
 *
 * @return void
 */
function daextlwcn_print_scripts_on_accept(){

	global $wpdb;
	$table_name = $wpdb->prefix . 'daextlwcn_category';
	$sql        = "SELECT * FROM $table_name ORDER BY priority ASC";
	$category_a = $wpdb->get_results( $sql, ARRAY_A );

	echo '<script>';
	echo 'window.DAEXTLWCN_ONACCEPT = {};';

	foreach ( $category_a as $category ) {

		echo 'window.DAEXTLWCN_ONACCEPT["' . intval($category['category_id'], 10) . '"] = function(){';
		echo stripslashes( $category['script_accept_cookies'] );
		echo '};';

	}

	echo '</script>';

}