<?php

/*
 * this class should be used to stores properties and methods shared by the
 * admin and public side of wordpress
 */

class Daextlwcn_Shared {

	//regex
	public $regex_number_ten_digits = '/^\s*\d{1,10}\s*$/';
	public $url_regex = '/^(http|https):\/\/[-A-Za-z0-9+&@#\/%?=~_|$!:,.;]+$/i';
	public $regex_capability = '/^\s*[A-Za-z0-9_]+\s*$/';
	public $hex_rgb_regex = '/^#(?:[0-9a-fA-F]{3}){1,2}$/';
	public $font_family_regex = '/^([A-Za-z0-9-\'", ]*)$/';

	protected static $instance = null;

	private $data = array();

	private function __construct() {

		add_action( 'daextlwcn_cron_hook', array( $this, 'daextlwcn_cron_exec' ) );

		//Set plugin textdomain
		load_plugin_textdomain( 'lightweight-cookie-notice', false, 'lightweight-cookie-notice/lang/' );

		$this->data['slug'] = 'daextlwcn';
		$this->data['ver']  = '1.34';
		$this->data['dir']  = substr( plugin_dir_path( __FILE__ ), 0, - 7 );
		$this->data['url']  = substr( plugin_dir_url( __FILE__ ), 0, - 7 );

		//Here are stored the plugin option with the related default values
		$this->data['options'] = [

			//Database Version -----------------------------------------------------------------------------------------
			$this->get( 'slug' ) . "_database_version"                                => "0",

			//General --------------------------------------------------------------------------------------------------
			$this->get( 'slug' ) . '_headings_font_family'                            => "'Open Sans', Helvetica, Arial, sans-serif",
			$this->get( 'slug' ) . '_headings_font_weight'                            => "600",
			$this->get( 'slug' ) . '_paragraphs_font_family'                          => "'Open Sans', Helvetica, Arial, sans-serif",
			$this->get( 'slug' ) . '_paragraphs_font_weight'                          => "400",
			$this->get( 'slug' ) . '_strong_tags_font_weight'                         => "600",
			$this->get( 'slug' ) . '_buttons_font_family'                             => "'Open Sans', Helvetica, Arial, sans-serif",
			$this->get( 'slug' ) . '_buttons_font_weight'                             => "400",
			$this->get( 'slug' ) . '_buttons_border_radius'                           => "4",
			$this->get( 'slug' ) . '_containers_border_radius'                        => "4",

			//Cookie Notice --------------------------------------------------------------------------------------------
			$this->get( 'slug' ) . '_cookie_notice_main_message_text'                 => esc_html__('This site uses cookies to improve your online experience, allow you to share content on social media, measure traffic to this website and display customised ads based on your browsing activity.', 'lightweight-cookie-notice'),
			$this->get( 'slug' ) . '_cookie_notice_main_message_font_color'           => "#666666",
			$this->get( 'slug' ) . '_cookie_notice_main_message_link_font_color'      => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_1_text'                     => esc_html__('Settings', 'lightweight-cookie-notice'),
			$this->get( 'slug' ) . '_cookie_notice_button_1_action'                   => "1",
			$this->get( 'slug' ) . '_cookie_notice_button_1_url'                      => "",
			$this->get( 'slug' ) . '_cookie_notice_button_1_background_color'         => "#ffffff",
			$this->get( 'slug' ) . '_cookie_notice_button_1_background_color_hover'   => "#ffffff",
			$this->get( 'slug' ) . '_cookie_notice_button_1_border_color'             => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_1_border_color_hover'       => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_1_font_color'               => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_1_font_color_hover'         => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_2_text'                     => esc_html__('Accept', 'lightweight-cookie-notice'),
			$this->get( 'slug' ) . '_cookie_notice_button_2_action'                   => "2",
			$this->get( 'slug' ) . '_cookie_notice_button_2_url'                      => "",
			$this->get( 'slug' ) . '_cookie_notice_button_2_background_color'         => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_2_background_color_hover'   => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_2_border_color'             => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_2_border_color_hover'       => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_2_font_color'               => "#ffffff",
			$this->get( 'slug' ) . '_cookie_notice_button_2_font_color_hover'         => "#ffffff",
			$this->get( 'slug' ) . '_cookie_notice_button_3_text'                     => esc_html__('Default Label', 'lightweight-cookie-notice'),
			$this->get( 'slug' ) . '_cookie_notice_button_3_action'                   => "0",
			$this->get( 'slug' ) . '_cookie_notice_button_3_url'                      => "",
			$this->get( 'slug' ) . '_cookie_notice_button_3_background_color'         => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_3_background_color_hover'   => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_3_border_color'             => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_3_border_color_hover'       => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_notice_button_3_font_color'               => "#ffffff",
			$this->get( 'slug' ) . '_cookie_notice_button_3_font_color_hover'         => "#ffffff",
			$this->get( 'slug' ) . '_cookie_notice_button_dismiss_action'             => "0",
			$this->get( 'slug' ) . '_cookie_notice_button_dismiss_url'                => "",
			$this->get( 'slug' ) . '_cookie_notice_button_dismiss_color'              => "#646464",
			$this->get( 'slug' ) . '_cookie_notice_container_position'                => "2",
			$this->get( 'slug' ) . '_cookie_notice_container_width'                   => "1140",
			$this->get( 'slug' ) . '_cookie_notice_container_opacity'                 => "1",
			$this->get( 'slug' ) . '_cookie_notice_container_border_width'            => "0",
			$this->get( 'slug' ) . '_cookie_notice_container_background_color'        => "#ffffff",
			$this->get( 'slug' ) . '_cookie_notice_container_border_color'            => "#e1e1e1",
			$this->get( 'slug' ) . '_cookie_notice_container_border_opacity'          => "1",
			$this->get( 'slug' ) . '_cookie_notice_container_drop_shadow'             => "1",
			$this->get( 'slug' ) . '_cookie_notice_container_drop_shadow_color'       => "#242f42",
			$this->get( 'slug' ) . '_cookie_notice_mask'                              => "1",
			$this->get( 'slug' ) . '_cookie_notice_mask_color'                        => "#242f42",
			$this->get( 'slug' ) . '_cookie_notice_mask_opacity'                      => "0",
			$this->get( 'slug' ) . '_cookie_notice_shake_effect'                      => "1",

			//Cookie Settings ------------------------------------------------------------------------------------------
			$this->get( 'slug' ) . '_cookie_settings_logo_url'                        => "",
			$this->get( 'slug' ) . '_cookie_settings_title'                           => esc_html__('Cookie Settings', 'lightweight-cookie-notice'),
			$this->get( 'slug' ) . '_cookie_settings_description_header'              => '<p>' . esc_html__('We want to be transparent about the data we and our partners collect and how we use it, so you can best exercise control over your personal data. For more information, please see our Privacy Policy.', 'lightweight-cookie-notice') . '</p><p><strong>' . esc_html__('Information we collect', 'lightweight-cookie-notice') . '</strong></p><p>' . esc_html__('We use this information to improve the performance and experience of our site visitors. This includes improving search results, showing more relevant content and promotional materials, better communication, and improved site performance.', 'lightweight-cookie-notice') . '<p>',
			$this->get( 'slug' ) . '_cookie_settings_toggle_on_color'                 => "#3a70c4",
			$this->get( 'slug' ) . '_cookie_settings_toggle_off_color'                => "#808080",
			$this->get( 'slug' ) . '_cookie_settings_toggle_misc_color'               => "#808080",
			$this->get( 'slug' ) . '_cookie_settings_toggle_disabled_color'           => "#e5e5e5",
			$this->get( 'slug' ) . '_cookie_settings_chevron_color'                   => "#6e6e6e",
			$this->get( 'slug' ) . '_cookie_settings_expand_close_color'              => "#6e6e6e",
			$this->get( 'slug' ) . '_cookie_settings_description_footer'              => '<p><strong>' . esc_html__('Information about cookies', 'lightweight-cookie-notice') . '</strong></p><p>' . esc_html__('We use the following essential and non-essential cookies to better improve your overall web browsing experience. Our partners use cookies and other mechanisms to connect you with your social networks and tailor advertising to better match your interests.', 'lightweight-cookie-notice') . '</p><p>' . esc_html__('You can make your choices by allowing categories of cookies by using the respective activation switches. Essential cookies cannot be rejected as without them certain core website functionalities would not work.', 'lightweight-cookie-notice') . '</p>',
			$this->get( 'slug' ) . '_cookie_settings_button_1_text'                   => esc_html__('Close', 'lightweight-cookie-notice'),
			$this->get( 'slug' ) . '_cookie_settings_button_1_action'                 => "2",
			$this->get( 'slug' ) . '_cookie_settings_button_1_url'                    => "",
			$this->get( 'slug' ) . '_cookie_settings_button_1_background_color'       => "#ffffff",
			$this->get( 'slug' ) . '_cookie_settings_button_1_background_color_hover' => "#ffffff",
			$this->get( 'slug' ) . '_cookie_settings_button_1_border_color'           => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_settings_button_1_border_color_hover'     => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_settings_button_1_font_color'             => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_settings_button_1_font_color_hover'       => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_settings_button_2_text'                   => esc_html__('Accept', 'lightweight-cookie-notice'),
			$this->get( 'slug' ) . '_cookie_settings_button_2_action'                 => "1",
			$this->get( 'slug' ) . '_cookie_settings_button_2_url'                    => "",
			$this->get( 'slug' ) . '_cookie_settings_button_2_background_color'       => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_settings_button_2_background_color_hover' => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_settings_button_2_border_color'           => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_settings_button_2_border_color_hover'     => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_settings_button_2_font_color'             => "#ffffff",
			$this->get( 'slug' ) . '_cookie_settings_button_2_font_color_hover'       => "#ffffff",
			$this->get( 'slug' ) . '_cookie_settings_headings_font_color'             => "#222222",
			$this->get( 'slug' ) . '_cookie_settings_paragraphs_font_color'           => "#666666",
			$this->get( 'slug' ) . '_cookie_settings_links_font_color'                => "#1e58b1",
			$this->get( 'slug' ) . '_cookie_settings_container_background_color'      => "#ffffff",
			$this->get( 'slug' ) . '_cookie_settings_container_opacity'               => "1.0",
			$this->get( 'slug' ) . '_cookie_settings_container_border_width'          => "0",
			$this->get( 'slug' ) . '_cookie_settings_container_border_color'          => "#e1e1e1",
			$this->get( 'slug' ) . '_cookie_settings_container_border_opacity'        => "1.0",
			$this->get( 'slug' ) . '_cookie_settings_container_drop_shadow'           => "1",
			$this->get( 'slug' ) . '_cookie_settings_container_drop_shadow_color'     => "#242f42",
			$this->get( 'slug' ) . '_cookie_settings_container_highlight_color'       => "#f8f8f8",
			$this->get( 'slug' ) . '_cookie_settings_separator_color'                 => "#e1e1e1",
			$this->get( 'slug' ) . '_cookie_settings_mask'                            => "1",
			$this->get( 'slug' ) . '_cookie_settings_mask_color'                      => "#242f42",
			$this->get( 'slug' ) . '_cookie_settings_mask_opacity'                    => "0.54",

			//Revisit Consent ------------------------------------------------------------------------------------------
			$this->get( 'slug' ) . '_revisit_consent_button_enable'                   => '1',
			$this->get( 'slug' ) . '_revisit_consent_button_tooltip_text'             => 'Cookie Settings',
			$this->get( 'slug' ) . '_revisit_consent_button_position'                 => 'left',
			$this->get( 'slug' ) . '_revisit_consent_button_background_color'         => '#1e58b1',
			$this->get( 'slug' ) . '_revisit_consent_button_icon_color'               => '#ffffff',

			//Geolocation ----------------------------------------------------------------------------------------------
			$this->get( 'slug' ) . '_enable_geolocation'                              => "0",
			$this->get( 'slug' ) . '_geolocation_service'                             => "0",
			$this->get( 'slug' ) . '_geolocation_behavior'                             => "0",
			$this->get( 'slug' ) . '_geolocation_locale'                              => [
				'at',
				'be',
				'bg',
				'cy',
				'cz',
				'dk',
				'ee',
				'fi',
				'fr',
				'hu',
				'ie',
				'it',
				'lv',
				'lt',
				'lu',
				'mt',
				'nl',
				'pl',
				'pt',
				'sk',
				'si',
				'es',
				'se',
				'gb'
			],
			$this->get( 'slug' ) . '_geolocation_subdivision'                         => [],
			$this->get( 'slug' ) . '_maxmind_license_key'                             => "",
			$this->get( 'slug' ) . '_maxmind_database_file_path'                      => $this->get_plugin_upload_path() . $this->generate_random_string_of_characters( 100 ) . '.mmdb',
			$this->get( 'slug' ) . '_maxmind_database_city_file_path'                      => $this->get_plugin_upload_path() . $this->generate_random_string_of_characters( 100 ) . '.mmdb',

			//Capabilities ---------------------------------------------------------------------------------------------
			$this->get( 'slug' ) . '_capability_menu_sections'                        => "edit_others_posts",
			$this->get( 'slug' ) . '_capability_menu_categories'                      => "edit_others_posts",
			$this->get( 'slug' ) . '_capability_menu_lists'                           => "edit_others_posts",
			$this->get( 'slug' ) . '_capability_menu_cookies'                         => "edit_others_posts",
			$this->get( 'slug' ) . '_capability_menu_import'                          => "manage_options",
			$this->get( 'slug' ) . '_capability_menu_export'                          => "manage_options",
			$this->get( 'slug' ) . '_capability_menu_maintenance'                     => "manage_options",

			//Advanced -------------------------------------------------------------------------------------------------
			$this->get( 'slug' ) . '_assets_mode'                                     => "1",
			$this->get( 'slug' ) . '_test_mode'                                       => "0",
			$this->get( 'slug' ) . '_cookie_expiration'                               => "0",
			$this->get( 'slug' ) . '_reload_page'                                     => "0",
			$this->get( 'slug' ) . '_category_acceptance'                             => "1",
			$this->get( 'slug' ) . '_transient_expiration'                            => "0",
			$this->get( 'slug' ) . '_google_font_url'                                 => "",
			$this->get( 'slug' ) . '_responsive_breakpoint'                           => "700",
			$this->get( 'slug' ) . '_cookie_table_columns'                            => [
				'name',
				'expiration',
				'purpose'
			],
			$this->get( 'slug' ) . '_force_css_specificity'                           => "1",
			$this->get( 'slug' ) . '_compress_output'                                 => "1",

		];

		//country list (ISO 3166-1 alpha-2)
		$geolocation_locale                                        = array(
			'Andorra'                                      => 'ad',
			'United Arab Emirates'                         => 'ae',
			'Afghanistan'                                  => 'af',
			'Antigua and Barbuda'                          => 'ag',
			'Anguilla'                                     => 'ai',
			'Albania'                                      => 'al',
			'Armenia'                                      => 'am',
			'Angola'                                       => 'ao',
			'Antartica'                                    => 'aq',
			'Argentina'                                    => 'ar',
			'American Samoa'                               => 'as',
			'Austria'                                      => 'at',
			'Australia'                                    => 'au',
			'Aruba'                                        => 'aw',
			'Åland Islands'                                => 'ax',
			'Azerbaijan'                                   => 'az',
			'Bosnia and Herzegovina'                       => 'ba',
			'Barbados'                                     => 'bb',
			'Bangladesh'                                   => 'bd',
			'Belgium'                                      => 'be',
			'Burkina Faso'                                 => 'bf',
			'Bulgaria'                                     => 'bg',
			'Bahrain'                                      => 'bh',
			'Burundi'                                      => 'bi',
			'Benin'                                        => 'bj',
			'Saint Barthélemy'                             => 'bl',
			'Bermuda'                                      => 'bm',
			'Brunei Darussalam'                            => 'bn',
			'Bolivia'                                      => 'bo',
			'Bonaire, Sint Eustatius and Saba'             => 'bq',
			'Brazil'                                       => 'br',
			'Bahamas'                                      => 'bs',
			'Bhutan'                                       => 'bt',
			'Bouvet Island'                                => 'bv',
			'Botswana'                                     => 'bw',
			'Belarus'                                      => 'by',
			'Belize'                                       => 'bz',
			'Canada'                                       => 'ca',
			'Cocos (Keeling) Islands'                      => 'cc',
			'Congo Democratic Republic'                    => 'cd',
			'Central African Republic'                     => 'cf',
			'Congo'                                        => 'cg',
			'Switzerland'                                  => 'ch',
			'Côte d\'Ivoire'                               => 'ci',
			'Cook Islands'                                 => 'ck',
			'Chile'                                        => 'cl',
			'Cameroon'                                     => 'cm',
			'China'                                        => 'cn',
			'Colombia'                                     => 'co',
			'Costa Rica'                                   => 'cr',
			'Cuba'                                         => 'cu',
			'Cape Verde'                                   => 'cv',
			'Curaçao'                                      => 'cw',
			'Christmas Island'                             => 'cx',
			'Cyprus'                                       => 'cy',
			'Czech Republic'                               => 'cz',
			'Germany'                                      => 'de',
			'Djibouti'                                     => 'dj',
			'Denmark'                                      => 'dk',
			'Dominica'                                     => 'dm',
			'Dominican Republic'                           => 'do',
			'Algeria'                                      => 'dz',
			'Ecuador'                                      => 'ec',
			'Estonia'                                      => 'ee',
			'Egypt'                                        => 'eg',
			'Western Sahara'                               => 'eh',
			'Eritrea'                                      => 'er',
			'Spain'                                        => 'es',
			'Ethiopia'                                     => 'et',
			'Finland'                                      => 'fi',
			'Fiji'                                         => 'fj',
			'Falkland Islands (Malvinas)'                  => 'fk',
			'Micronesia Federated States of'               => 'fm',
			'Faroe Islands'                                => 'fo',
			'France'                                       => 'fr',
			'Gabon'                                        => 'ga',
			'United Kingdom'                               => 'gb',
			'Grenada'                                      => 'gd',
			'Georgia'                                      => 'ge',
			'French Guiana'                                => 'gf',
			'Guernsey'                                     => 'gg',
			'Ghana'                                        => 'gh',
			'Gibraltar'                                    => 'gi',
			'Greenland'                                    => 'gl',
			'Gambia'                                       => 'gm',
			'Guinea'                                       => 'gn',
			'Guadeloupe'                                   => 'gp',
			'Equatorial Guinea'                            => 'gq',
			'Greece'                                       => 'gr',
			'South Georgia and the South Sandwich Islands' => 'gs',
			'Guatemala'                                    => 'gt',
			'Guam'                                         => 'gu',
			'Guinea-Bissau'                                => 'gw',
			'Guyana'                                       => 'gy',
			'Hong Kong'                                    => 'hk',
			'Heard Island and McDonald Islands'            => 'hm',
			'Honduras'                                     => 'hn',
			'Croatia'                                      => 'hr',
			'Haiti'                                        => 'ht',
			'Hungary'                                      => 'hu',
			'Indonesia'                                    => 'id',
			'Ireland'                                      => 'ie',
			'Israel'                                       => 'il',
			'Isle of Man'                                  => 'im',
			'India'                                        => 'in',
			'British Indian Ocean Territory'               => 'io',
			'Iraq'                                         => 'iq',
			'Iran, Islamic Republic of'                    => 'ir',
			'Iceland'                                      => 'is',
			'Italy'                                        => 'it',
			'Jersey'                                       => 'je',
			'Jamaica'                                      => 'jm',
			'Jordan'                                       => 'jo',
			'Japan'                                        => 'jp',
			'Kenya'                                        => 'ke',
			'Kyrgyzstan'                                   => 'kg',
			'Cambodia'                                     => 'kh',
			'Kiribati'                                     => 'ki',
			'Comoros'                                      => 'km',
			'Saint Kitts and Nevis'                        => 'kn',
			'Korea, Democratic People\'s Republic of'      => 'kp',
			'Korea, Republic of'                           => 'kr',
			'Kuwait'                                       => 'kw',
			'Cayman Islands'                               => 'ky',
			'Kazakhstan'                                   => 'kz',
			'Lao People\'s Democratic Republic'            => 'la',
			'Lebanon'                                      => 'la',
			'Saint Lucia'                                  => 'lc',
			'Liechtenstein'                                => 'li',
			'Sri Lanka'                                    => 'lk',
			'Liberia'                                      => 'lr',
			'Lesotho'                                      => 'ls',
			'Lithuania'                                    => 'lt',
			'Luxembourg'                                   => 'lu',
			'Latvia'                                       => 'lv',
			'Libya'                                        => 'ly',
			'Morocco'                                      => 'ma',
			'Monaco'                                       => 'mc',
			'Moldova, Republic of'                         => 'md',
			'Montenegro'                                   => 'me',
			'Saint Martin (French part)'                   => 'mf',
			'Madagascar'                                   => 'mg',
			'Marshall Islands'                             => 'mh',
			'Macedonia, the former Yugoslav Republic of'   => 'mk',
			'Mali'                                         => 'ml',
			'Myanmar'                                      => 'mm',
			'Mongolia'                                     => 'mn',
			'Macao'                                        => 'mo',
			'Northern Mariana Islands'                     => 'mp',
			'Martinique'                                   => 'mq',
			'Mauritania'                                   => 'mr',
			'Montserrat'                                   => 'ms',
			'Malta'                                        => 'mt',
			'Mauritius'                                    => 'mu',
			'Maldives'                                     => 'mv',
			'Malawi'                                       => 'mw',
			'Mexico'                                       => 'mx',
			'Malaysia'                                     => 'my',
			'Mozambique'                                   => 'mz',
			'Namibia'                                      => 'na',
			'New Caledonia'                                => 'nc',
			'Niger'                                        => 'ne',
			'Norfolk Island'                               => 'nf',
			'Nigeria'                                      => 'ng',
			'Nicaragua'                                    => 'ni',
			'Netherlands'                                  => 'nl',
			'Norway'                                       => 'no',
			'Nepal'                                        => 'np',
			'Nauru'                                        => 'nr',
			'Niue'                                         => 'nu',
			'New Zealand'                                  => 'nz',
			'Oman'                                         => 'om',
			'Panama'                                       => 'pa',
			'Peru'                                         => 'pe',
			'French Polynesia'                             => 'pf',
			'Papua New Guinea'                             => 'pg',
			'Philippines'                                  => 'ph',
			'Pakistan'                                     => 'pk',
			'Poland'                                       => 'pl',
			'Saint Pierre and Miquelon'                    => 'pm',
			'Pitcairn'                                     => 'pn',
			'Puerto Rico'                                  => 'pr',
			'Palestine, State of'                          => 'ps',
			'Portugal'                                     => 'pt',
			'Palau'                                        => 'pw',
			'Paraguay'                                     => 'py',
			'Qatar'                                        => 'qa',
			'Réunion'                                      => 're',
			'Romania'                                      => 'ro',
			'Serbia'                                       => 'rs',
			'Russian Federation'                           => 'ru',
			'Rwanda'                                       => 'rw',
			'Saudi Arabia'                                 => 'sa',
			'Solomon Islands'                              => 'sb',
			'Seychelles'                                   => 'sc',
			'Sudan'                                        => 'sd',
			'Sweden'                                       => 'se',
			'Singapore'                                    => 'sg',
			'Saint Helena, Ascension and Tristan da Cunha' => 'sh',
			'Slovenia'                                     => 'si',
			'Svalbard and Jan Mayen'                       => 'sj',
			'Slovakia'                                     => 'sk',
			'Sierra Leone'                                 => 'sl',
			'San Marino'                                   => 'sm',
			'Senegal'                                      => 'sn',
			'Somalia'                                      => 'so',
			'Suriname'                                     => 'sr',
			'South Sudan'                                  => 'ss',
			'Sao Tome and Principe'                        => 'st',
			'El Salvador'                                  => 'sv',
			'Sint Maarten (Dutch part)'                    => 'sx',
			'Syrian Arab Republic'                         => 'sy',
			'Swaziland'                                    => 'sz',
			'Turks and Caicos Islands'                     => 'tc',
			'Chad'                                         => 'td',
			'French Southern Territories'                  => 'tf',
			'Togo'                                         => 'tg',
			'Thailand'                                     => 'th',
			'Tajikistan'                                   => 'tj',
			'Tokelau'                                      => 'tk',
			'Timor-Leste'                                  => 'tl',
			'Turkmenistan'                                 => 'tm',
			'Tunisia'                                      => 'tn',
			'Tonga'                                        => 'to',
			'Turkey'                                       => 'tr',
			'Trinidad and Tobago'                          => 'tt',
			'Tuvalu'                                       => 'tv',
			'Taiwan, Province of China'                    => 'tw',
			'Tanzania, United Republic of'                 => 'tz',
			'Ukraine'                                      => 'ua',
			'Uganda'                                       => 'ug',
			'United States Minor Outlying Islands'         => 'um',
			'United States'                                => 'us',
			'Uruguay'                                      => 'uy',
			'Uzbekistan'                                   => 'uz',
			'Holy See (Vatican City State)'                => 'va',
			'Saint Vincent and the Grenadines'             => 'vc',
			'Venezuela, Bolivarian Republic of'            => 've',
			'Virgin Islands, British'                      => 'vg',
			'Virgin Islands, U.S.'                         => 'vi',
			'Viet Nam'                                     => 'vn',
			'Vanuatu'                                      => 'vu',
			'Wallis and Futuna'                            => 'wf',
			'Samoa'                                        => 'ws',
			'Yemen'                                        => 'ye',
			'Mayotte'                                      => 'yt',
			'South Africa'                                 => 'za',
			'Zambia'                                       => 'zm',
			'Zimbabwe'                                     => 'zw'
		);
		$this->data['options'][ $this->get( 'slug' ) . '_locale' ] = $geolocation_locale;

	}

	public static function get_instance() {

		if ( null == self::$instance ) {
			self::$instance = new self;
		}

		return self::$instance;

	}

	//retrieve data
	public function get( $index ) {
		return $this->data[ $index ];
	}

	/*
	 * If $needle is present in the $haystack array echos 'selected="selected"'.
	 *
	 * @param $haystack Array
	 * @param $needle String
	 */
	public function selected_array( $array, $needle ) {

		if ( is_array( $array ) and in_array( $needle, $array ) ) {
			return 'selected="selected"';
		}

	}

	/*
	 * Returns true if one or more categories are using the specified section.
	 *
	 * @param $section_id Int
	 * @return bool
	 */
	public function section_is_used_in_categories( $section_id ) {

		global $wpdb;

		$table_name  = $wpdb->prefix . $this->get( 'slug' ) . "_category";
		$safe_sql    = $wpdb->prepare( "SELECT COUNT(*) FROM $table_name WHERE section_id = %d", $section_id );
		$total_items = $wpdb->get_var( $safe_sql );

		if ( $total_items > 0 ) {
			return true;
		} else {
			return false;
		}

	}

	/*
	 * Returns true if one or more cookies are using the specified category.
	 *
	 * @param $category_id Int
	 * @return bool
	 */
	public function category_is_used_in_cookies( $category_id ) {

		global $wpdb;

		$table_name  = $wpdb->prefix . $this->get( 'slug' ) . "_cookie";
		$safe_sql    = $wpdb->prepare( "SELECT COUNT(*) FROM $table_name WHERE category_id = %d", $category_id );
		$total_items = $wpdb->get_var( $safe_sql );

		if ( $total_items > 0 ) {
			return true;
		} else {
			return false;
		}

	}

	/**
	 * Verifies if the provided IP address belongs to a country included in the "Geolocation Locale" option.
	 *
	 * @param $ip_address
	 *
	 * @return bool Returns True if the country associated with the IP address is included in the "Geolocation Locale"
	 * option, otherwise returns false.
	 * @throws \MaxMind\Db\Reader\InvalidDatabaseException
	 */
	public function is_valid_locale_maxmind_geolite2( $ip_address ) {

		$result = false;

		//Create the Reader object
		$file_path = get_option( $this->get( 'slug' ) . '_maxmind_database_file_path' );
		$reader    = new GeoIp2\Database\Reader( $file_path );

		//Get the country
		try {
			$record = $reader->country( $ip_address );
		} catch ( Exception $e ) {
			return null;
		}

		//Create the Reader object for the city database
		$database_city_file_path = get_option( $this->get( 'slug' ) . '_maxmind_database_city_file_path' );
		$reader_city    = new GeoIp2\Database\Reader( $database_city_file_path );

		//Get the city data
		try {
			$record_city = $reader_city->city($ip_address);
		} catch ( Exception $e ) {
			return null;
		}

		//Get the list of the countries from the "Geolocation Locale" option.
		$country_iso_code     = $record->country->isoCode;
		$geolocation_locale   = get_option( $this->get( 'slug' ) . '_geolocation_locale' );
		$geolocation_locale_a = maybe_unserialize( $geolocation_locale );

		//Verify if the detected locale is present in the list of the countries.
		if ( is_array( $geolocation_locale_a ) ) {
			foreach ( $geolocation_locale_a as $key => $single_geolocation_locale ) {
				if ( mb_strtolower( $single_geolocation_locale ) === mb_strtolower( $country_iso_code ) ) {
					$result = true;
				}
			}
		}

		//Get the list of the subdivisions from the "Geolocation Subdivisions" option.
		$subdivision_iso_code = $country_iso_code . '-' . $record_city->subdivisions[0]->isoCode;
		$geolocation_subdivision   = get_option( $this->get( 'slug' ) . '_geolocation_subdivision' );
		$geolocation_subdivision_a = maybe_unserialize( $geolocation_subdivision );

		//Verify if the detected subdivision is present in the list of the subdivisions.
		if ( is_array( $geolocation_subdivision_a ) ) {
			foreach ( $geolocation_subdivision_a as $key => $single_geolocation_subdivision ) {
				if ( mb_strtolower( $single_geolocation_subdivision ) === mb_strtolower( $subdivision_iso_code ) ) {
					$result = true;
				}
			}
		}

		return $result;

	}

	/**
	 * Get the IP address of the user. If the retrieved IP address is not valid an empty string is returned.
	 *
	 * @return string
	 */
	public function get_ip_address() {

		$ip_address = $_SERVER['REMOTE_ADDR'];

		if ( rest_is_ip_address( $ip_address ) ) {
			return $ip_address;
		} else {
			return '';
		}

	}

	/**
	 * Get the plugin upload path.
	 *
	 * @return string The plugin updload path
	 */
	public function get_plugin_upload_path() {

		$upload_path = WP_CONTENT_DIR . '/uploads/daextlwcn_uploads/';

		return $upload_path;

	}

	/**
	 * Generates a string of random characters.
	 *
	 * @param int $length The lenght of the returned string.
	 *
	 * @return string A string of random characters.
	 */
	public function generate_random_string_of_characters( $length = 100 ) {
		$characters        = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$characters_length = strlen( $characters );
		$random_string     = '';
		for ( $i = 0; $i < $length; $i ++ ) {
			$random_string .= $characters[ rand( 0, $characters_length - 1 ) ];
		}

		return $random_string;
	}

	/**
	 * Update the MaxMind GeoLite2 database.
	 */
	public function daextlwcn_cron_exec() {

		require_once( $this->get( 'dir' ) . '/admin/inc/class-daextlwcn-maxmind-integration.php' );
		$this->maxmind_integration = new Daextlwcn_MaxMind_Integration( $this, true );
		$this->maxmind_integration->update_maxmind_geolite2('Country');
		$this->maxmind_integration->update_maxmind_geolite2('City');

	}

	/*
	 * Generates the XML version of the data of the table.
	 *
	 * @param db_table_name The name of the db table without the prefix.
	 * @param db_table_primary_key The name of the primary key of the table
	 * @return String The XML version of the data of the db table
	 */
	public function convert_db_table_to_xml( $db_table_name, $db_table_primary_key ) {

		$out = '';

		//Get the data from the db table
		global $wpdb;
		$table_name = $wpdb->prefix . $this->get( 'slug' ) . "_$db_table_name";
		$data_a     = $wpdb->get_results( "SELECT * FROM $table_name ORDER BY $db_table_primary_key ASC", ARRAY_A );

		//Generate the data of the db table
		foreach ( $data_a as $record ) {

			$out .= "<$db_table_name>";

			//Get all the indexes of the $data array
			$record_keys = array_keys( $record );

			//Cycle through all the indexes of the single record and create all the XML tags
			foreach ( $record_keys as $key ) {
				$out .= "<" . $key . ">" . esc_attr( $record[ $key ] ) . "</" . $key . ">";
			}

			$out .= "</$db_table_name>";

		}

		return $out;

	}

	/*
	 * Objects as a value are set to empty strings. This prevent generating notices with the methods of the wpdb class.
	 *
	 * @param $data An array which includes objects that should be converted to a empty strings.
	 * @return string An array where the objects have been replaced with empty strings.
	 */
	public function replace_objects_with_empty_strings( $data ) {

		foreach ( $data as $key => $value ) {
			if ( gettype( $value ) === 'object' ) {
				$data[ $key ] = '';
			}
		}

		return $data;

	}

	/**
	 * Reset the plugin options.
	 *
	 * Set the initial value to all the plugin options.
	 */
	public function reset_plugin_options() {

		$options = $this->get( 'options' );
		foreach ( $options as $option_name => $default_option_value ) {
			update_option( $option_name, $default_option_value );
		}

	}

	/**
	 * Get the name of a section.
	 *
	 * @param $section_id
	 *
	 * @return false
	 */
	public function get_section_name( $section_id ) {

		global $wpdb;
		$table_name  = $wpdb->prefix . $this->get( 'slug' ) . "_section";
		$safe_sql    = $wpdb->prepare( "SELECT name FROM $table_name WHERE section_id = %d",
			$section_id );
		$section_obj = $wpdb->get_row( $safe_sql );

		if ( $section_obj !== null ) {
			return $section_obj->name;
		} else {
			return __('None', 'lightweight-cookie-notice');
		}

	}

	/**
	 * Filters the provided string with wp_kses() and custom parameters.
	 *
	 * @param $string The string that should be filtered
	 *
	 * @return The filtered string.
	 */
	public function apply_custom_kses( $string ) {

		$allowed_html = array(
			'p'      => array(),
			'a'      => array(
				'href'   => array(),
				'title'  => array(),
				'target' => array(),
				'rel'    => array()
			),
			'strong' => array(),
			'br'     => array(),
			'ol'     => array(),
			'ul'     => array(),
			'li'     => array(),
		);

		return wp_kses( $string, $allowed_html );

	}

	/**
	 * Get the number of seconds associated with the provided identifier of a time period defined with the "Cookie
	 * Expiration" option.
	 *
	 * @param $period
	 *
	 * @return float|int
	 */
	public function get_cookie_expiration_seconds( $period ) {

		switch ( intval( $period, 10 ) ) {

			//Unlimited
			case 0:
				$expiration = 3153600000;
				break;

			//One Hour
			case 1:
				$expiration = 3600;
				break;

			//One Day
			case 2:
				$expiration = 3600 * 24;
				break;

			//One Week
			case 3:
				$expiration = 3600 * 24 * 7;
				break;

			//One Month
			case 4:
				$expiration = 3600 * 24 * 30;
				break;

			//Three Months
			case 5:
				$expiration = 3600 * 2490;
				break;

			//Six Months
			case 6:
				$expiration = 3600 * 24 * 180;
				break;

			//One Year
			case 7:
				$expiration = 3600 * 24 * 365;
				break;

		}

		return $expiration;

	}

	/**
	 * Delete all the records of the database tables used by the plugin.
	 */
	public function reset_plugin_database_tables() {

		//Delete data in 'category' table
		global $wpdb;
		$table_name = $wpdb->prefix . $this->get( 'slug' ) . "_category";
		$wpdb->query( "DELETE FROM $table_name" );

		//Delete data in 'section' table
		global $wpdb;
		$table_name = $wpdb->prefix . $this->get( 'slug' ) . "_section";
		$wpdb->query( "DELETE FROM $table_name" );

		//Delete data in 'cookie' table
		global $wpdb;
		$table_name = $wpdb->prefix . $this->get( 'slug' ) . "_cookie";
		$wpdb->query( "DELETE FROM $table_name" );

		//Delete data in 'category_acceptance' table
		global $wpdb;
		$table_name = $wpdb->prefix . $this->get( 'slug' ) . "_category_acceptance";
		$wpdb->query( "DELETE FROM $table_name" );

	}

	/**
	 * Returns the category acceptance of the provided category.
	 *
	 * @param $category_id
	 *
	 * @return string
	 */
	public function get_category_acceptance( $category_id ) {

		$counter_accepted = 0;

		global $wpdb;
		$table_name            = $wpdb->prefix . $this->get( 'slug' ) . "_category_acceptance";
		$sql                   = $wpdb->prepare( "SELECT * FROM $table_name WHERE category_id = %d", $category_id );
		$category_acceptance_a = $wpdb->get_results( $sql, ARRAY_A );

		//Get the total number of accepted states for this category
		foreach ( $category_acceptance_a as $key => $category_acceptance ) {
			if ( intval( $category_acceptance['state'], 10 ) === 1 ) {
				$counter_accepted ++;
			}
		}

		if ( count( $category_acceptance_a ) === 0 ) {
			$result = 'N/A';
		} else {
			$result = (string) round( $counter_accepted / count( $category_acceptance_a ) * 100, 2 );
			$result = $result . '%';
		}

		return $result;

	}

}