<?php

/**
 * This class adds the options with the related callbacks and validations.
 */
class Daextlwcn_Menu_Options {

	private $shared = null;

	public function __construct( $shared ) {

		//assign an instance of the plugin info
		$this->shared = $shared;

	}

	public function register_options() {

		//Section General ----------------------------------------------------------------------------------------------
		add_settings_section(
			'daextlwcn_general_settings_section',
			null,
			null,
			'daextlwcn_general_options'
		);

		add_settings_field(
			'headings_font_family',
			esc_html__( 'Headings Font Familly', 'lightweight-cookie-notice'),
			array( $this, 'headings_font_family_callback' ),
			'daextlwcn_general_options',
			'daextlwcn_general_settings_section'
		);

		register_setting(
			'daextlwcn_general_options',
			'daextlwcn_headings_font_family',
			array( $this, 'headings_font_family_validation' )
		);

		add_settings_field(
			'headings_font_weight',
			esc_html__( 'Headings Font Weight', 'lightweight-cookie-notice'),
			array( $this, 'headings_font_weight_callback' ),
			'daextlwcn_general_options',
			'daextlwcn_general_settings_section'
		);

		register_setting(
			'daextlwcn_general_options',
			'daextlwcn_headings_font_weight',
			array( $this, 'headings_font_weight_validation' )
		);

		add_settings_field(
			'paragraphs_font_family',
			esc_html__( 'Paragraphs Font Family', 'lightweight-cookie-notice'),
			array( $this, 'paragraphs_font_family_callback' ),
			'daextlwcn_general_options',
			'daextlwcn_general_settings_section'
		);

		register_setting(
			'daextlwcn_general_options',
			'daextlwcn_paragraphs_font_family',
			array( $this, 'paragraphs_font_family_validation' )
		);

		add_settings_field(
			'paragraphs_font_weight',
			esc_html__( 'Paragraphs Font Weight', 'lightweight-cookie-notice'),
			array( $this, 'paragraphs_font_weight_callback' ),
			'daextlwcn_general_options',
			'daextlwcn_general_settings_section'
		);

		register_setting(
			'daextlwcn_general_options',
			'daextlwcn_paragraphs_font_weight',
			array( $this, 'paragraphs_font_weight_validation' )
		);

		add_settings_field(
			'strong_tags_font_weight',
			esc_html__( 'Strong Tags Font Weight', 'lightweight-cookie-notice'),
			array( $this, 'strong_tags_font_weight_callback' ),
			'daextlwcn_general_options',
			'daextlwcn_general_settings_section'
		);

		register_setting(
			'daextlwcn_general_options',
			'daextlwcn_strong_tags_font_weight',
			array( $this, 'strong_tags_font_weight_validation' )
		);

		add_settings_field(
			'buttons_font_family',
			esc_html__( 'Buttons Font Family', 'lightweight-cookie-notice'),
			array( $this, 'buttons_font_family_callback' ),
			'daextlwcn_general_options',
			'daextlwcn_general_settings_section'
		);

		register_setting(
			'daextlwcn_general_options',
			'daextlwcn_buttons_font_family',
			array( $this, 'buttons_font_family_validation' )
		);

		add_settings_field(
			'buttons_font_weight',
			esc_html__( 'Buttons Font Weight', 'lightweight-cookie-notice'),
			array( $this, 'buttons_font_weight_callback' ),
			'daextlwcn_general_options',
			'daextlwcn_general_settings_section'
		);

		register_setting(
			'daextlwcn_general_options',
			'daextlwcn_buttons_font_weight',
			array( $this, 'buttons_font_weight_validation' )
		);

		add_settings_field(
			'buttons_border_radius',
			esc_html__( 'Buttons Border Radius', 'lightweight-cookie-notice'),
			array( $this, 'buttons_border_radius_callback' ),
			'daextlwcn_general_options',
			'daextlwcn_general_settings_section'
		);

		register_setting(
			'daextlwcn_general_options',
			'daextlwcn_buttons_border_radius',
			array( $this, 'buttons_border_radius_validation' )
		);

		add_settings_field(
			'containers_border_radius',
			esc_html__( 'Containers Border Radius', 'lightweight-cookie-notice'),
			array( $this, 'containers_border_radius_callback' ),
			'daextlwcn_general_options',
			'daextlwcn_general_settings_section'
		);

		register_setting(
			'daextlwcn_general_options',
			'daextlwcn_containers_border_radius',
			array( $this, 'containers_border_radius_validation' )
		);

		//Section Cookie Notice ----------------------------------------------------------------------------------------
		add_settings_section(
			'daextlwcn_cookie_notice_settings_section',
			null,
			null,
			'daextlwcn_cookie_notice_options'
		);

		add_settings_field(
			'main_message_text',
			esc_html__( 'Message Text', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_main_message_text_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);


		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_main_message_text',
			array( $this, 'cookie_notice_main_message_text_validation' )
		);

		add_settings_field(
			'cookie_notice_main_message_font_color',
			esc_html__( 'Message Font Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_main_message_font_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_main_message_font_color',
			array( $this, 'cookie_notice_main_message_font_color_validation' )
		);

		add_settings_field(
			'cookie_notice_main_message_link_font_color',
			esc_html__( 'Message Link Font Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_main_message_link_font_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_main_message_link_font_color',
			array( $this, 'cookie_notice_main_message_link_font_color_validation' )
		);

		add_settings_field(
			'cookie_notice_button_1_text',
			esc_html__( 'Button 1 Text', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_1_text_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_1_text',
			array( $this, 'cookie_notice_button_1_text_validation' )
		);

		add_settings_field(
			'cookie_notice_button_1_action',
			esc_html__( 'Button 1 Action', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_1_action_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_1_action',
			array( $this, 'cookie_notice_button_1_action_validation' )
		);

		add_settings_field(
			'cookie_notice_button_1_url',
			esc_html__( 'Button 1 URL', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_1_url_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_1_url',
			array( $this, 'cookie_notice_button_1_url_validation' )
		);

		add_settings_field(
			'cookie_notice_button_1_background_color',
			esc_html__( 'Button 1 Background Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_1_background_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_1_background_color',
			array( $this, 'cookie_notice_button_1_background_color_validation' )
		);

		add_settings_field(
			'cookie_notice_button_1_background_color_hover',
			esc_html__( 'Button 1 Background Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_1_background_color_hover_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_1_background_color_hover',
			array( $this, 'cookie_notice_button_1_background_color_hover_validation' )
		);

		add_settings_field(
			'cookie_notice_button_1_border_color',
			esc_html__( 'Button 1 Border Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_1_border_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_1_border_color',
			array( $this, 'cookie_notice_button_1_border_color_validation' )
		);

		add_settings_field(
			'cookie_notice_button_1_border_color_hover',
			esc_html__( 'Button 1 Border Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_1_border_color_hover_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_1_border_color_hover',
			array( $this, 'cookie_notice_button_1_border_color_hover_validation' )
		);

		add_settings_field(
			'cookie_notice_button_1_font_color',
			esc_html__( 'Button 1 Font Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_1_font_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_1_font_color',
			array( $this, 'cookie_notice_button_1_font_color_validation' )
		);

		add_settings_field(
			'cookie_notice_button_1_font_color_hover',
			esc_html__( 'Button 1 Font Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_1_font_color_hover_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_1_font_color_hover',
			array( $this, 'cookie_notice_button_1_font_color_hover_validation' )
		);

		add_settings_field(
			'cookie_notice_button_2_text',
			esc_html__( 'Button 2 Text', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_2_text_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_2_text',
			array( $this, 'cookie_notice_button_2_text_validation' )
		);

		add_settings_field(
			'cookie_notice_button_2_action',
			esc_html__( 'Button 2 Action', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_2_action_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_2_action',
			array( $this, 'cookie_notice_button_2_action_validation' )
		);

		add_settings_field(
			'cookie_notice_button_2_url',
			esc_html__( 'Button 2 URL', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_2_url_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_2_url',
			array( $this, 'cookie_notice_button_2_url_validation' )
		);

		add_settings_field(
			'cookie_notice_button_2_background_color',
			esc_html__( 'Button 2 Background Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_2_background_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_2_background_color',
			array( $this, 'cookie_notice_button_2_background_color_validation' )
		);

		add_settings_field(
			'cookie_notice_button_2_background_color_hover',
			esc_html__( 'Button 2 Background Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_2_background_color_hover_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_2_background_color_hover',
			array( $this, 'cookie_notice_button_2_background_color_hover_validation' )
		);

		add_settings_field(
			'cookie_notice_button_2_border_color',
			esc_html__( 'Button 2 Border Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_2_border_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_2_border_color',
			array( $this, 'cookie_notice_button_2_border_color_validation' )
		);

		add_settings_field(
			'cookie_notice_button_2_border_color_hover',
			esc_html__( 'Button 2 Border Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_2_border_color_hover_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_2_border_color_hover',
			array( $this, 'cookie_notice_button_2_border_color_hover_validation' )
		);

		add_settings_field(
			'cookie_notice_button_2_font_color',
			esc_html__( 'Button 2 Font Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_2_font_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_2_font_color',
			array( $this, 'cookie_notice_button_2_font_color_validation' )
		);

		add_settings_field(
			'cookie_notice_button_2_font_color_hover',
			esc_html__( 'Button 2 Font Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_2_font_color_hover_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_2_font_color_hover',
			array( $this, 'cookie_notice_button_2_font_color_hover_validation' )
		);

		add_settings_field(
			'cookie_notice_button_3_text',
			esc_html__( 'Button 3 Text', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_3_text_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_3_text',
			array( $this, 'cookie_notice_button_3_text_validation' )
		);

		add_settings_field(
			'cookie_notice_button_3_action',
			esc_html__( 'Button 3 Action', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_3_action_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_3_action',
			array( $this, 'cookie_notice_button_3_action_validation' )
		);

		add_settings_field(
			'cookie_notice_button_3_url',
			esc_html__( 'Button 3 URL', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_3_url_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_3_url',
			array( $this, 'cookie_notice_button_3_url_validation' )
		);

		add_settings_field(
			'cookie_notice_button_3_background_color',
			esc_html__( 'Button 3 Background Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_3_background_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_3_background_color',
			array( $this, 'cookie_notice_button_3_background_color_validation' )
		);

		add_settings_field(
			'cookie_notice_button_3_background_color_hover',
			esc_html__( 'Button 3 Background Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_3_background_color_hover_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_3_background_color_hover',
			array( $this, 'cookie_notice_button_3_background_color_hover_validation' )
		);

		add_settings_field(
			'cookie_notice_button_3_border_color',
			esc_html__( 'Button 3 Border Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_3_border_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_3_border_color',
			array( $this, 'cookie_notice_button_3_border_color_validation' )
		);

		add_settings_field(
			'cookie_notice_button_3_border_color_hover',
			esc_html__( 'Button 3 Border Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_3_border_color_hover_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_3_border_color_hover',
			array( $this, 'cookie_notice_button_3_border_color_hover_validation' )
		);

		add_settings_field(
			'cookie_notice_button_3_font_color',
			esc_html__( 'Button 3 Font Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_3_font_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_3_font_color',
			array( $this, 'cookie_notice_button_3_font_color_validation' )
		);

		add_settings_field(
			'cookie_notice_button_3_font_color_hover',
			esc_html__( 'Button 3 Font Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_3_font_color_hover_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_3_font_color_hover',
			array( $this, 'cookie_notice_button_3_font_color_hover_validation' )
		);

		add_settings_field(
			'cookie_notice_button_dismiss_action',
			esc_html__( 'Button Dismiss Action', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_dismiss_action_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_dismiss_action',
			array( $this, 'cookie_notice_button_dismiss_action_validation' )
		);

		add_settings_field(
			'cookie_notice_button_dismiss_url',
			esc_html__( 'Button Dismiss URL', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_dismiss_url_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_dismiss_url',
			array( $this, 'cookie_notice_button_dismiss_url_validation' )
		);

		add_settings_field(
			'cookie_notice_button_dismiss_color',
			esc_html__( 'Dismiss Button Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_button_dismiss_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_button_dismiss_color',
			array( $this, 'cookie_notice_button_dismiss_color_validation' )
		);

		add_settings_field(
			'cookie_notice_container_position',
			esc_html__( 'Container Position', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_container_position_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_container_position',
			array( $this, 'cookie_notice_container_position_validation' )
		);

		add_settings_field(
			'cookie_notice_container_width',
			esc_html__( 'Wrapper Width', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_container_width_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_container_width',
			array( $this, 'cookie_notice_container_width_validation' )
		);

		add_settings_field(
			'cookie_notice_container_background_color',
			esc_html__( 'Container Background Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_container_background_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_container_background_color',
			array( $this, 'cookie_notice_container_background_color_validation' )
		);

		add_settings_field(
			'cookie_notice_container_opacity',
			esc_html__( 'Container Opacity', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_container_opacity_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_container_opacity',
			array( $this, 'cookie_notice_container_opacity_validation' )
		);

		add_settings_field(
			'cookie_notice_container_border_width',
			esc_html__( 'Container Border Width', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_container_border_width_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_container_border_width',
			array( $this, 'cookie_notice_container_border_width_validation' )
		);

		add_settings_field(
			'cookie_notice_container_border_color',
			esc_html__( 'Container Border Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_container_border_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_container_border_color',
			array( $this, 'cookie_notice_container_border_color_validation' )
		);

		add_settings_field(
			'cookie_notice_container_border_opacity',
			esc_html__( 'Container Border Opacity', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_container_border_opacity_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_container_border_opacity',
			array( $this, 'cookie_notice_container_border_opacity_validation' )
		);

		add_settings_field(
			'cookie_notice_container_drop_shadow',
			esc_html__( 'Container Drop Shadow', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_container_drop_shadow_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_container_drop_shadow',
			array( $this, 'cookie_notice_container_drop_shadow_validation' )
		);

		add_settings_field(
			'cookie_notice_container_drop_shadow_color',
			esc_html__( 'Container Drop Shadow Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_container_drop_shadow_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_container_drop_shadow_color',
			array( $this, 'cookie_notice_container_drop_shadow_color_validation' )
		);

		add_settings_field(
			'cookie_notice_mask',
			esc_html__( 'Mask', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_mask_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_mask',
			array( $this, 'cookie_notice_mask_validation' )
		);

		add_settings_field(
			'cookie_notice_mask_color',
			esc_html__( 'Mask Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_mask_color_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_mask_color',
			array( $this, 'cookie_notice_mask_color_validation' )
		);

		add_settings_field(
			'cookie_notice_mask_opacity',
			esc_html__( 'Mask Opacity', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_mask_opacity_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_mask_opacity',
			array( $this, 'cookie_notice_mask_opacity_validation' )
		);

		add_settings_field(
			'cookie_notice_shake_effect',
			esc_html__( 'Shake Effect', 'lightweight-cookie-notice'),
			array( $this, 'cookie_notice_shake_effect_callback' ),
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_notice_options',
			'daextlwcn_cookie_notice_shake_effect',
			array( $this, 'cookie_notice_shake_effect_validation' )
		);

		//Section Cookie Settings --------------------------------------------------------------------------------------
		add_settings_section(
			'daextlwcn_cookie_settings_settings_section',
			null,
			null,
			'daextlwcn_cookie_settings_options'
		);

		add_settings_field(
			'cookie_settings_logo_url',
			esc_html__( 'Logo URL', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_logo_url_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_logo_url',
			array( $this, 'cookie_settings_logo_url_validation' )
		);

		add_settings_field(
			'cookie_settings_title',
			esc_html__( 'Title', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_title_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_title',
			array( $this, 'cookie_settings_title_validation' )
		);

		add_settings_field(
			'cookie_settings_description_header',
			esc_html__( 'Description Header', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_description_header_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_description_header',
			array( $this, 'cookie_settings_description_header_validation' )
		);

		add_settings_field(
			'cookie_settings_toggle_on_color',
			esc_html__( 'Toggle On Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_toggle_on_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_toggle_on_color',
			array( $this, 'cookie_settings_toggle_on_color_validation' )
		);

		add_settings_field(
			'cookie_settings_toggle_off_color',
			esc_html__( 'Toggle Off Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_toggle_off_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_toggle_off_color',
			array( $this, 'cookie_settings_toggle_off_color_validation' )
		);

		add_settings_field(
			'cookie_settings_toggle_misc_color',
			esc_html__( 'Toggle Misc Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_toggle_misc_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_toggle_misc_color',
			array( $this, 'cookie_settings_toggle_misc_color_validation' )
		);

		add_settings_field(
			'cookie_settings_toggle_disabled_color',
			esc_html__( 'Toggle Disabled Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_toggle_disabled_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_toggle_disabled_color',
			array( $this, 'cookie_settings_toggle_disabled_color_validation' )
		);

		add_settings_field(
			'cookie_settings_chevron_color',
			esc_html__( 'Chevron Icon Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_chevron_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_chevron_color',
			array( $this, 'cookie_settings_chevron_color_validation' )
		);

		add_settings_field(
			'cookie_settings_expand_close_color',
			esc_html__( 'Expand Icon Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_expand_close_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_expand_close_color',
			array( $this, 'cookie_settings_expand_close_color_validation' )
		);

		add_settings_field(
			'cookie_settings_description_footer',
			esc_html__( 'Description Footer', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_description_footer_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_description_footer',
			array( $this, 'cookie_settings_description_footer_validation' )
		);

		add_settings_field(
			'cookie_settings_cookie_settings_button_1_text',
			esc_html__( 'Button 1 Text', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_1_text_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_1_text',
			array( $this, 'cookie_settings_button_1_text_validation' )
		);

		add_settings_field(
			'cookie_settings_cookie_settings_button_1_action',
			esc_html__( 'Button 1 Action', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_1_action_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_1_action',
			array( $this, 'cookie_settings_button_1_action_validation' )
		);

		add_settings_field(
			'cookie_settings_cookie_settings_button_1_url',
			esc_html__( 'Button 1 Url', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_1_url_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_1_url',
			array( $this, 'cookie_settings_button_1_url_validation' )
		);

		add_settings_field(
			'cookie_settings_button_1_background_color',
			esc_html__( 'Button 1 Background Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_1_background_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_1_background_color',
			array( $this, 'cookie_settings_button_1_background_color_validation' )
		);

		add_settings_field(
			'cookie_settings_button_1_background_color_hover',
			esc_html__( 'Button 1 Background Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_1_background_color_hover_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_1_background_color_hover',
			array( $this, 'cookie_settings_button_1_background_color_hover_validation' )
		);

		add_settings_field(
			'cookie_settings_button_1_border_color',
			esc_html__( 'Button 1 Border Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_1_border_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_1_border_color',
			array( $this, 'cookie_settings_button_1_border_color_validation' )
		);

		add_settings_field(
			'cookie_settings_button_1_border_color_hover',
			esc_html__( 'Button 1 Border Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_1_border_color_hover_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_1_border_color_hover',
			array( $this, 'cookie_settings_button_1_border_color_hover_validation' )
		);

		add_settings_field(
			'cookie_settings_button_1_font_color',
			esc_html__( 'Button 1 Font Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_1_font_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_1_font_color',
			array( $this, 'cookie_settings_button_1_font_color_validation' )
		);

		add_settings_field(
			'cookie_settings_button_1_font_color_hover',
			esc_html__( 'Button 1 Font Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_1_font_color_hover_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_1_font_color_hover',
			array( $this, 'cookie_settings_button_1_font_color_hover_validation' )
		);

		add_settings_field(
			'cookie_settings_cookie_settings_button_2_text',
			esc_html__( 'Button 2 Text', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_2_text_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_2_text',
			array( $this, 'cookie_settings_button_2_text_validation' )
		);

		add_settings_field(
			'cookie_settings_cookie_settings_button_2_action',
			esc_html__( 'Button 2 Action', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_2_action_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_2_action',
			array( $this, 'cookie_settings_button_2_action_validation' )
		);

		add_settings_field(
			'cookie_settings_cookie_settings_button_2_url',
			esc_html__( 'Button 2 Url', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_2_url_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_2_url',
			array( $this, 'cookie_settings_button_2_url_validation' )
		);

		add_settings_field(
			'cookie_settings_button_2_background_color',
			esc_html__( 'Button 2 Background Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_2_background_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_2_background_color',
			array( $this, 'cookie_settings_button_2_background_color_validation' )
		);

		add_settings_field(
			'cookie_settings_button_2_background_color_hover',
			esc_html__( 'Button 2 Background Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_2_background_color_hover_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_2_background_color_hover',
			array( $this, 'cookie_settings_button_2_background_color_hover_validation' )
		);

		add_settings_field(
			'cookie_settings_button_2_border_color',
			esc_html__( 'Button 2 Border Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_2_border_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_2_border_color',
			array( $this, 'cookie_settings_button_2_border_color_validation' )
		);

		add_settings_field(
			'cookie_settings_button_2_border_color_hover',
			esc_html__( 'Button 2 Border Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_2_border_color_hover_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_2_border_color_hover',
			array( $this, 'cookie_settings_button_2_border_color_hover_validation' )
		);

		add_settings_field(
			'cookie_settings_button_2_font_color',
			esc_html__( 'Button 2 Font Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_2_font_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_2_font_color',
			array( $this, 'cookie_settings_button_2_font_color_validation' )
		);

		add_settings_field(
			'cookie_settings_button_2_font_color_hover',
			esc_html__( 'Button 2 Font Color Hover', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_button_2_font_color_hover_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_button_2_font_color_hover',
			array( $this, 'cookie_settings_button_2_font_color_hover_validation' )
		);

		add_settings_field(
			'cookie_settings_headings_font_color',
			esc_html__( 'Headings Font Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_headings_font_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_headings_font_color',
			array( $this, 'cookie_settings_headings_font_color_validation' )
		);

		add_settings_field(
			'cookie_settings_paragraphs_font_color',
			esc_html__( 'Paragraphs Font Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_paragraphs_font_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_paragraphs_font_color',
			array( $this, 'cookie_settings_paragraphs_font_color_validation' )
		);

		add_settings_field(
			'cookie_settings_links_font_color',
			esc_html__( 'Links Font Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_links_font_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_links_font_color',
			array( $this, 'cookie_settings_links_font_color_validation' )
		);

		add_settings_field(
			'cookie_settings_container_background_color',
			esc_html__( 'Container Background Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_container_background_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_container_background_color',
			array( $this, 'cookie_settings_container_background_color_validation' )
		);

		add_settings_field(
			'cookie_settings_container_opacity',
			esc_html__( 'Container Opacity', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_container_opacity_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_container_opacity',
			array( $this, 'cookie_settings_container_opacity_validation' )
		);

		add_settings_field(
			'cookie_settings_container_border_width',
			esc_html__( 'Container Border Width', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_container_border_width_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_container_border_width',
			array( $this, 'cookie_settings_container_border_width_validation' )
		);

		add_settings_field(
			'cookie_settings_container_border_color',
			esc_html__( 'Container Border Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_container_border_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_container_border_color',
			array( $this, 'cookie_settings_container_border_color_validation' )
		);

		add_settings_field(
			'cookie_settings_container_border_opacity',
			esc_html__( 'Container Border Opacity', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_container_border_opacity_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_container_border_opacity',
			array( $this, 'cookie_settings_container_border_opacity_validation' )
		);

		add_settings_field(
			'cookie_settings_container_drop_shadow',
			esc_html__( 'Container Drop Shadow', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_container_drop_shadow_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_container_drop_shadow',
			array( $this, 'cookie_settings_container_drop_shadow_validation' )
		);

		add_settings_field(
			'cookie_settings_container_drop_shadow_color',
			esc_html__( 'Container Drop Shadow Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_container_drop_shadow_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_container_drop_shadow_color',
			array( $this, 'cookie_settings_container_drop_shadow_color_validation' )
		);

		add_settings_field(
			'cookie_settings_container_highlight_color',
			esc_html__( 'Container Highlight Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_container_highlight_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_container_highlight_color',
			array( $this, 'cookie_settings_container_highlight_color_validation' )
		);

		add_settings_field(
			'cookie_settings_separator_color',
			esc_html__( 'Separator Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_separator_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_separator_color',
			array( $this, 'cookie_settings_separator_color_validation' )
		);

		add_settings_field(
			'cookie_settings_mask_color',
			esc_html__( 'Mask Color', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_mask_color_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_mask_color',
			array( $this, 'cookie_settings_mask_color_validation' )
		);

		add_settings_field(
			'cookie_settings_mask_opacity',
			esc_html__( 'Mask Opacity', 'lightweight-cookie-notice'),
			array( $this, 'cookie_settings_mask_opacity_callback' ),
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_settings_section'
		);

		register_setting(
			'daextlwcn_cookie_settings_options',
			'daextlwcn_cookie_settings_mask_opacity',
			array( $this, 'cookie_settings_mask_opacity_validation' )
		);

		//Revisit Consent Button ---------------------------------------------------------------------------------------
		add_settings_section(
			'daextlwcn_revisit_consent_button_settings_section',
			null,
			null,
			'daextlwcn_revisit_consent_button_options'
		);

		add_settings_field(
			'revisit_consent_button_enable',
			esc_html__( 'Enable', 'lightweight-cookie-notice'),
			array( $this, 'revisit_consent_button_enable_callback' ),
			'daextlwcn_revisit_consent_button_options',
			'daextlwcn_revisit_consent_button_settings_section'
		);

		register_setting(
			'daextlwcn_revisit_consent_button_options',
			'daextlwcn_revisit_consent_button_enable',
			array( $this, 'revisit_consent_button_enable_validation' )
		);

		add_settings_field(
			'revisit_consent_button_tooltip_text',
			esc_html__( 'Tooltip Text', 'lightweight-cookie-notice'),
			array( $this, 'revisit_consent_button_tooltip_text_callback' ),
			'daextlwcn_revisit_consent_button_options',
			'daextlwcn_revisit_consent_button_settings_section'
		);

		register_setting(
			'daextlwcn_revisit_consent_button_options',
			'daextlwcn_revisit_consent_button_tooltip_text',
			array( $this, 'revisit_consent_button_tooltip_textenable_validation' )
		);

		add_settings_field(
			'revisit_consent_button_position',
			esc_html__( 'Position', 'lightweight-cookie-notice'),
			array( $this, 'revisit_consent_button_position_callback' ),
			'daextlwcn_revisit_consent_button_options',
			'daextlwcn_revisit_consent_button_settings_section'
		);

		register_setting(
			'daextlwcn_revisit_consent_button_options',
			'daextlwcn_revisit_consent_button_position',
			array( $this, 'revisit_consent_button_position_validation' )
		);

		add_settings_field(
			'revisit_consent_button_background_color',
			esc_html__( 'Background Color', 'lightweight-cookie-notice'),
			array( $this, 'revisit_consent_button_background_color_callback' ),
			'daextlwcn_revisit_consent_button_options',
			'daextlwcn_revisit_consent_button_settings_section'
		);

		register_setting(
			'daextlwcn_revisit_consent_button_options',
			'daextlwcn_revisit_consent_button_background_color',
			array( $this, 'revisit_consent_button_background_color_validation' )
		);

		add_settings_field(
			'revisit_consent_button_icon_color',
			esc_html__( 'Icon Color', 'lightweight-cookie-notice'),
			array( $this, 'revisit_consent_button_icon_color_callback' ),
			'daextlwcn_revisit_consent_button_options',
			'daextlwcn_revisit_consent_button_settings_section'
		);

		register_setting(
			'daextlwcn_revisit_consent_button_options',
			'daextlwcn_revisit_consent_button_icon_color',
			array( $this, 'revisit_consent_button_icon_color_validation' )
		);

		//Section Geolocation ------------------------------------------------------------------------------------------
		add_settings_section(
			'daextlwcn_geolocation_settings_section',
			null,
			null,
			'daextlwcn_geolocation_options'
		);

		add_settings_field(
			'enable_geolocation',
			esc_html__( 'Geolocation', 'lightweight-cookie-notice'),
			array( $this, 'enable_geolocation_callback' ),
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_settings_section'
		);

		register_setting(
			'daextlwcn_geolocation_options',
			'daextlwcn_enable_geolocation',
			array( $this, 'enable_geolocation_validation' )
		);

		add_settings_field(
			'geolocation_behavior',
			esc_html__( 'Behavior', 'lightweight-cookie-notice'),
			array( $this, 'geolocation_behavior_callback' ),
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_settings_section'
		);

		register_setting(
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_behavior',
			array( $this, 'geolocation_behavior_validation' )
		);

		add_settings_field(
			'geolocation_service',
			esc_html__( 'Geolocation Service', 'lightweight-cookie-notice'),
			array( $this, 'geolocation_service_callback' ),
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_settings_section'
		);

		register_setting(
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_service',
			array( $this, 'geolocation_service_validation' )
		);

		add_settings_field(
			'geolocation_locale',
			esc_html__( 'Geolocation Locale', 'lightweight-cookie-notice'),
			array( $this, 'geolocation_locale_callback' ),
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_settings_section'
		);

		register_setting(
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_locale',
			array( $this, 'geolocation_locale_validation' )
		);

		add_settings_field(
			'geolocation_subdivision',
			esc_html__( 'Geolocation Subdivision', 'lightweight-cookie-notice'),
			array( $this, 'geolocation_subdivision_callback' ),
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_settings_section'
		);

		register_setting(
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_subdivision',
			array( $this, 'geolocation_subdivision_validation' )
		);

		add_settings_field(
			'maxmind_license_key',
			esc_html__( 'MaxMind License Key', 'lightweight-cookie-notice'),
			array( $this, 'maxmind_license_key_callback' ),
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_settings_section'
		);

		register_setting(
			'daextlwcn_geolocation_options',
			'daextlwcn_maxmind_license_key',
			array( $this, 'maxmind_license_key_validation' )
		);

		add_settings_field(
			'maxmind_database_file_path',
			esc_html__( 'MaxMind Database File Path', 'lightweight-cookie-notice'),
			array( $this, 'maxmind_database_file_path_callback' ),
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_settings_section'
		);

		register_setting(
			'daextlwcn_geolocation_options',
			'daextlwcn_maxmind_database_file_path',
			array( $this, 'maxmind_database_file_path_validation' )
		);

		add_settings_field(
			'maxmind_database_city_file_path',
			esc_html__( 'MaxMind Database City File Path', 'lightweight-cookie-notice'),
			array( $this, 'maxmind_database_city_file_path_callback' ),
			'daextlwcn_geolocation_options',
			'daextlwcn_geolocation_settings_section'
		);

		register_setting(
			'daextlwcn_geolocation_options',
			'daextlwcn_maxmind_database_city_file_path',
			array( $this, 'maxmind_database_city_file_path_validation' )
		);

		//Section Capabilities -----------------------------------------------------------------------------------------
		add_settings_section(
			'daextlwcn_capabilities_settings_section',
			null,
			null,
			'daextlwcn_capabilities_options'
		);

		add_settings_field(
			'capability_menu_sections',
			esc_html__( 'Sections Menu', 'lightweight-cookie-notice'),
			array( $this, 'capability_menu_sections_callback' ),
			'daextlwcn_capabilities_options',
			'daextlwcn_capabilities_settings_section'
		);

		register_setting(
			'daextlwcn_capabilities_options',
			'daextlwcn_capability_menu_sections',
			array( $this, 'capability_menu_sections_validation' )
		);

		add_settings_field(
			'capability_menu_categories',
			esc_html__( 'Categories Menu', 'lightweight-cookie-notice'),
			array( $this, 'capability_menu_categories_callback' ),
			'daextlwcn_capabilities_options',
			'daextlwcn_capabilities_settings_section'
		);

		register_setting(
			'daextlwcn_capabilities_options',
			'daextlwcn_capability_menu_categories',
			array( $this, 'capability_menu_categories_validation' )
		);

		add_settings_field(
			'capability_menu_cookies',
			esc_html__( 'Cookies Menu', 'lightweight-cookie-notice'),
			array( $this, 'capability_menu_cookies_callback' ),
			'daextlwcn_capabilities_options',
			'daextlwcn_capabilities_settings_section'
		);

		register_setting(
			'daextlwcn_capabilities_options',
			'daextlwcn_capability_menu_cookies',
			array( $this, 'capability_menu_cookies_validation' )
		);

		add_settings_field(
			'capability_menu_import',
			esc_html__( 'Import Menu', 'lightweight-cookie-notice'),
			array( $this, 'capability_menu_import_callback' ),
			'daextlwcn_capabilities_options',
			'daextlwcn_capabilities_settings_section'
		);

		register_setting(
			'daextlwcn_capabilities_options',
			'daextlwcn_capability_menu_import',
			array( $this, 'capability_menu_import_validation' )
		);

		add_settings_field(
			'capability_menu_export',
			esc_html__( 'Export Menu', 'lightweight-cookie-notice'),
			array( $this, 'capability_menu_export_callback' ),
			'daextlwcn_capabilities_options',
			'daextlwcn_capabilities_settings_section'
		);

		register_setting(
			'daextlwcn_capabilities_options',
			'daextlwcn_capability_menu_export',
			array( $this, 'capability_menu_export_validation' )
		);

		add_settings_field(
			'capability_menu_maintenance',
			esc_html__( 'Maintenance Menu', 'lightweight-cookie-notice'),
			array( $this, 'capability_menu_maintenance_callback' ),
			'daextlwcn_capabilities_options',
			'daextlwcn_capabilities_settings_section'
		);

		register_setting(
			'daextlwcn_capabilities_options',
			'daextlwcn_capability_menu_maintenance',
			array( $this, 'capability_menu_maintenance_validation' )
		);

		//Section Advanced ---------------------------------------------------------------------------------------------
		add_settings_section(
			'daextlwcn_advanced_settings_section',
			null,
			null,
			'daextlwcn_advanced_options'
		);

		add_settings_field(
			'assets_mode',
			esc_html__( 'Assets Mode', 'lightweight-cookie-notice'),
			array( $this, 'assets_mode_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_assets_mode',
			array( $this, 'assets_mode_validation' )
		);

		add_settings_field(
			'test_mode',
			esc_html__( 'Test Mode', 'lightweight-cookie-notice'),
			array( $this, 'test_mode_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_test_mode',
			array( $this, 'test_mode_validation' )
		);

		add_settings_field(
			'cookie_expiration',
			esc_html__( 'Cookie Expiration', 'lightweight-cookie-notice'),
			array( $this, 'cookie_expiration_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_cookie_expiration',
			array( $this, 'cookie_expiration_validation' )
		);

		add_settings_field(
			'reload_page',
			esc_html__( 'Reload Page', 'lightweight-cookie-notice'),
			array( $this, 'reload_page_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_reload_page',
			array( $this, 'reload_page_validation' )
		);

		add_settings_field(
			'category_acceptance',
			esc_html__( 'Category Acceptance', 'lightweight-cookie-notice'),
			array( $this, 'category_acceptance_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_category_acceptance',
			array( $this, 'category_acceptance_validation' )
		);

		add_settings_field(
			'transient_expiration',
			esc_html__( 'Transient Expiration', 'lightweight-cookie-notice'),
			array( $this, 'transient_expiration_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_transient_expiration',
			array( $this, 'transient_expiration_validation' )
		);

		add_settings_field(
			'google_font_url',
			esc_html__( 'Google Font URL', 'lightweight-cookie-notice'),
			array( $this, 'google_font_url_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_google_font_url',
			array( $this, 'google_font_url_validation' )
		);

		add_settings_field(
			'responsive_breakpoint',
			esc_html__( 'Responsive Breakpoint', 'lightweight-cookie-notice'),
			array( $this, 'responsive_breakpoint_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_responsive_breakpoint',
			array( $this, 'responsive_breakpoint_validation' )
		);

		add_settings_field(
			'cookie_table_columns',
			esc_html__( 'Cookie Table Columns', 'lightweight-cookie-notice'),
			array( $this, 'cookie_table_columns_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_cookie_table_columns',
			array( $this, 'cookie_table_columns_validation' )
		);

		add_settings_field(
			'force_css_specificity',
			esc_html__( 'Force CSS Specificity', 'lightweight-cookie-notice'),
			array( $this, 'force_css_specificity_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_force_css_specificity',
			array( $this, 'force_css_specificity_validation' )
		);

		add_settings_field(
			'compress_output',
			esc_html__( 'Compress Output', 'lightweight-cookie-notice'),
			array( $this, 'compress_output_callback' ),
			'daextlwcn_advanced_options',
			'daextlwcn_advanced_settings_section'
		);

		register_setting(
			'daextlwcn_advanced_options',
			'daextlwcn_compress_output',
			array( $this, 'compress_output_validation' )
		);

	}

	//General options callbacks and validations ------------------------------------------------------------------------
	public function cookie_settings_logo_url_callback( $args ) {

		$html = '<input maxlength="2048" type="text" id="daextlwcn_cookie_settings_logo_url" name="daextlwcn_cookie_settings_logo_url" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_logo_url" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The URL of the logo.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_logo_url_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_settings_logo_url', 'daextlwcn_cookie_settings_logo_url',
				esc_html__( 'Please enter a valid value in the "Logo URL" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_logo_url' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_title_callback( $args ) {

		$html = '<input maxlength="1000" type="text" id="daextlwcn_cookie_settings_title" name="daextlwcn_cookie_settings_title" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_title" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The title of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_title_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_settings_title', 'daextlwcn_cookie_settings_title',
				esc_html__( 'Please enter a valid value in the "Title" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_title' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_description_header_callback( $args ) {

		$html = '<textarea id="daextlwcn_cookie_settings_description_header" name="daextlwcn_cookie_settings_description_header" maxlength="10000">' . esc_html( get_option( "daextlwcn_cookie_settings_description_header" ) ) . '</textarea>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The description displayed in the header of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_description_header_validation( $input ) {

		$input = $this->shared->apply_custom_kses( $input );

		if ( strlen( $input ) > 100000 ) {
			add_settings_error( 'daextlwcn_cookie_settings_description_header',
				'daextlwcn_cookie_settings_description_header',
				esc_html__( 'Toggle On Color', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_description_header' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_toggle_on_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_toggle_on_color" name="daextlwcn_cookie_settings_toggle_on_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_toggle_on_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the active toggles displayed in the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_toggle_on_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_toggle_on_color',
				'daextlwcn_cookie_settings_toggle_on_color',
				esc_attr__( 'Please enter a valid color in the "Toggle On Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_toggle_on_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_toggle_off_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_toggle_off_color" name="daextlwcn_cookie_settings_toggle_off_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_toggle_off_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the inactive toggles displayed in the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_toggle_off_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_toggle_off_color',
				'daextlwcn_cookie_settings_toggle_off_color',
				esc_attr__( 'Please enter a valid color in the "Toggle Off Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_toggle_off_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_toggle_misc_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_toggle_misc_color" name="daextlwcn_cookie_settings_toggle_misc_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_toggle_misc_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the miscellaneous toggles displayed in the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_toggle_misc_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_toggle_misc_color',
				'daextlwcn_cookie_settings_toggle_misc_color',
				esc_attr__( 'Please enter a valid color in the "Toggle Misc Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_toggle_misc_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_toggle_disabled_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_toggle_disabled_color" name="daextlwcn_cookie_settings_toggle_disabled_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_toggle_disabled_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the disabled toggles displayed in the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_toggle_disabled_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_toggle_disabled_color',
				'daextlwcn_cookie_settings_toggle_disabled_color',
				esc_attr__( 'Please enter a valid color in the "Toggle Disabled Option" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_toggle_disabled_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_separator_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_separator_color" name="daextlwcn_cookie_settings_separator_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_separator_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The color of the borders.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_separator_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_separator_color',
				'daextlwcn_cookie_settings_separator_color',
				esc_attr__( 'Please enter a valid color in the "Separator Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_separator_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_chevron_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_chevron_color" name="daextlwcn_cookie_settings_chevron_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_chevron_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the chevron icon displayed in the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_chevron_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_chevron_color', 'daextlwcn_cookie_settings_chevron_color',
				esc_attr__( 'Please enter a valid color in the "Chevron Icon Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_chevron_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_expand_close_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_expand_close_color" name="daextlwcn_cookie_settings_expand_close_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_expand_close_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the expand icon displayed in the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_expand_close_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_expand_close_color',
				'daextlwcn_cookie_settings_expand_close_color',
				esc_attr__( 'Please enter a valid color in the "Expand Icon Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_expand_close_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_1_text_callback( $args ) {

		$html = '<input maxlength="1000" type="text" id="daextlwcn_cookie_settings_button_1_text" name="daextlwcn_cookie_settings_button_1_text" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_1_text" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the text of the button 1 of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_1_text_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_1_text', 'daextlwcn_cookie_settings_button_1_text',
				esc_html__( 'Please enter a valid value in the "Button 1 Text" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_1_text' );
		} else {
			$output = $input;
		}

		return $output;

	}


	public function cookie_settings_button_1_action_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_settings_button_1_action" name="daextlwcn_cookie_settings_button_1_action" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_1_action" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_1_action" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Accept Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_1_action" ) ), 2,
				false ) . ' value="2">' . esc_html__( 'Close Cookie Settings', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_1_action" ) ), 3,
				false ) . ' value="3">' . esc_html__( 'Redirect to URL', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_1_action" ) ), 4,
				false ) . ' value="4">' . esc_html__( 'Accept All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_1_action" ) ), 5,
				false ) . ' value="5">' . esc_html__( 'Reject All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The action performed after clicking the button 1 of the cookie settings.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_settings_button_1_action_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_settings_button_1_url_callback( $args ) {

		$html = '<input maxlength="2048" type="text" id="daextlwcn_cookie_settings_button_1_url" name="daextlwcn_cookie_settings_button_1_url" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_1_url" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The URL where the user will be redirected after clicking the button 1 of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_1_url_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_1_url', 'daextlwcn_cookie_settings_button_1_url',
				esc_html__( 'Please enter a valid value in the "Button 2 Text" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_1_url' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_2_text_callback( $args ) {

		$html = '<input maxlength="1000" type="text" id="daextlwcn_cookie_settings_button_2_text" name="daextlwcn_cookie_settings_button_2_text" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_2_text" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the text of the button 2 of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_2_text_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 2000 ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_2_text', 'daextlwcn_cookie_settings_button_2_text',
				esc_html__( 'Please enter a valid value in the "Button 2 Text" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_2_text' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_2_action_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_settings_button_2_action" name="daextlwcn_cookie_settings_button_2_action" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_2_action" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_2_action" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Accept Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_2_action" ) ), 2,
				false ) . ' value="2">' . esc_html__( 'Close Cookie Settings', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_2_action" ) ), 3,
				false ) . ' value="3">' . esc_html__( 'Redirect to URL', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_2_action" ) ), 4,
				false ) . ' value="4">' . esc_html__( 'Accept All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_button_2_action" ) ), 5,
				false ) . ' value="5">' . esc_html__( 'Reject All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The action performed after clicking the button 2 of the cookie settings.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_settings_button_2_action_validation( $input ) {

		return intval( $input, 10 );

	}


	public function cookie_settings_button_2_url_callback( $args ) {

		$html = '<input maxlength="2048" type="text" id="daextlwcn_cookie_settings_button_2_url" name="daextlwcn_cookie_settings_button_2_url" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_2_url" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The URL where the user will be redirected after clicking the button 2 of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_2_url_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 2000 ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_2_url', 'daextlwcn_cookie_settings_button_2_url',
				esc_html__( 'Please enter a valid value in the "Description Footer" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_2_url' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_3_text_callback( $args ) {

		$html = '<input maxlength="3048" type="text" id="daextlwcn_cookie_notice_button_3_text" name="daextlwcn_cookie_notice_button_3_text" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_3_text" ) ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the text of the button 3 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_3_text_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_3_text', 'daextlwcn_cookie_notice_button_3_text',
				esc_html__( 'Please enter a valid value in the "Button 3 Text" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_3_text' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_3_action_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_notice_button_3_action" name="daextlwcn_cookie_notice_button_3_action" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_3_action" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_3_action" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Open Cookie Settings', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_3_action" ) ), 2,
				false ) . ' value="2">' . esc_html__( 'Accept Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_3_action" ) ), 3,
				false ) . ' value="3">' . esc_html__( 'Close Cookie Notice', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_3_action" ) ), 4,
				false ) . ' value="4">' . esc_html__( 'Redirect to URL', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_3_action" ) ), 5,
				false ) . ' value="5">' . esc_html__( 'Accept All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_3_action" ) ), 6,
				false ) . ' value="6">' . esc_html__( 'Reject All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The action performed after clicking the button 3 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_notice_button_3_action_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_notice_button_3_url_callback( $args ) {

		$html = '<input maxlength="2048" type="text" id="daextlwcn_cookie_notice_button_3_url" name="daextlwcn_cookie_notice_button_3_url" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_3_url" ) ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The URL where the user will be redirected after clicking the button 3 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_3_url_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_3_url', 'daextlwcn_cookie_notice_button_3_url',
				esc_html__( 'Please enter a valid value in the "Button 3 URL" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_3_url' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_3_background_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_3_background_color" name="daextlwcn_cookie_notice_button_3_background_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_3_background_color" )) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the button 3 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_3_background_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_3_background_color',
				'daextlwcn_cookie_notice_button_3_background_color',
				esc_attr__( 'Please enter a valid color in the "Button 3 Background Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_3_background_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_3_background_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_3_background_color_hover" name="daextlwcn_cookie_notice_button_3_background_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_3_background_color_hover" )) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the button 3 in hover state of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_3_background_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_3_background_color_hover',
				'daextlwcn_cookie_notice_button_3_background_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 3 Background Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_3_background_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_3_border_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_3_border_color" name="daextlwcn_cookie_notice_button_3_border_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_3_border_color" )) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the button 3 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_3_border_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_3_border_color',
				'daextlwcn_cookie_notice_button_3_border_color',
				esc_attr__( 'Please enter a valid color in the "Button 3 Border Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_3_border_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_3_border_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_3_border_color_hover" name="daextlwcn_cookie_notice_button_3_border_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_3_border_color_hover" )) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the button 3 in hover state of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_3_border_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_3_border_color_hover',
				'daextlwcn_cookie_notice_button_3_border_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 3 Border Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_3_border_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_3_font_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_3_font_color" name="daextlwcn_cookie_notice_button_3_font_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_3_font_color" )) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the button 3 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_3_font_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_3_font_color',
				'daextlwcn_cookie_notice_button_3_font_color',
				esc_attr__( 'Please enter a valid color in the "Button 3 Font Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_3_font_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_3_font_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_3_font_color_hover" name="daextlwcn_cookie_notice_button_3_font_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_3_font_color_hover" )) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the button 3 in hover state of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_3_font_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_3_font_color_hover',
				'daextlwcn_cookie_notice_button_3_font_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 3 Font Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_3_font_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_description_footer_callback( $args ) {

		$html = '<textarea id="daextlwcn_cookie_settings_description_footer" name="daextlwcn_cookie_settings_description_footer" maxlength="10000">' . esc_html( get_option( "daextlwcn_cookie_settings_description_footer" ) ) . '</textarea>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The description displayed in the footer of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_description_footer_validation( $input ) {

		$input = $this->shared->apply_custom_kses( $input );

		if ( strlen( $input ) > 100000 ) {
			add_settings_error( 'daextlwcn_cookie_settings_description_footer',
				'daextlwcn_cookie_settings_description_footer',
				esc_html__( 'Please enter a valid value in the "Description Footer" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_description_footer' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_main_message_text_callback( $args ) {

		$html = '<textarea id="daextlwcn_cookie_notice_main_message_text" name="daextlwcn_cookie_notice_main_message_text" maxlength="10000">' . esc_html( get_option( "daextlwcn_cookie_notice_main_message_text" ) ) . '</textarea>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Enter the text of the message displayed in the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_main_message_text_validation( $input ) {

		$input = $this->shared->apply_custom_kses( $input );

		if ( strlen( $input ) > 10000 ) {
			add_settings_error( 'daextlwcn_cookie_notice_main_message_text',
				'daextlwcn_cookie_notice_main_message_text',
				esc_html__( 'Please enter a valid value in the "Button 1 Text" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_main_message_text' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_1_text_callback( $args ) {

		$html = '<input maxlength="2048" type="text" id="daextlwcn_cookie_notice_button_1_text" name="daextlwcn_cookie_notice_button_1_text" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_1_text" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the text of the button 1 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_1_text_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_1_text', 'daextlwcn_cookie_notice_button_1_text',
				esc_html__( 'Please enter a valid value in the "Button 1 Text" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_1_text' );
		} else {
			$output = $input;
		}

		return $output;

	}


	public function cookie_notice_button_1_action_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_notice_button_1_action" name="daextlwcn_cookie_notice_button_1_action" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_1_action" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_1_action" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Open Cookie Settings', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_1_action" ) ), 2,
				false ) . ' value="2">' . esc_html__( 'Accept Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_1_action" ) ), 3,
				false ) . ' value="3">' . esc_html__( 'Close Cookie Notice', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_1_action" ) ), 4,
				false ) . ' value="4">' . esc_html__( 'Redirect to URL', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_1_action" ) ), 5,
				false ) . ' value="5">' . esc_html__( 'Accept All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_1_action" ) ), 6,
				false ) . ' value="6">' . esc_html__( 'Reject All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The action performed after clicking the button 1 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_notice_button_1_action_validation( $input ) {

		return intval( $input, 10 );

	}


	public function cookie_notice_button_1_url_callback( $args ) {

		$html = '<input maxlength="2048" type="text" id="daextlwcn_cookie_notice_button_1_url" name="daextlwcn_cookie_notice_button_1_url" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_1_url" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The URL where the user will be redirected after clicking the button 1 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_1_url_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_1_url', 'daextlwcn_cookie_notice_button_1_url',
				esc_html__( 'Please enter a valid value in the "Button 1 URL" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_1_url' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_2_text_callback( $args ) {

		$html = '<input maxlength="2048" type="text" id="daextlwcn_cookie_notice_button_2_text" name="daextlwcn_cookie_notice_button_2_text" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_2_text" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the text of the button 2 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_2_text_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_2_text', 'daextlwcn_cookie_notice_button_2_text',
				esc_html__( 'Please enter a valid value in the "Button 2 Text" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_2_text' );
		} else {
			$output = $input;
		}

		return $output;

	}


	public function cookie_notice_button_2_action_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_notice_button_2_action" name="daextlwcn_cookie_notice_button_2_action" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_2_action" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_2_action" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Open Cookie Settings', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_2_action" ) ), 2,
				false ) . ' value="2">' . esc_html__( 'Accept Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_2_action" ) ), 3,
				false ) . ' value="3">' . esc_html__( 'Close Cookie Notice', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_2_action" ) ), 4,
				false ) . ' value="4">' . esc_html__( 'Redirect to URL', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_2_action" ) ), 5,
				false ) . ' value="5">' . esc_html__( 'Accept All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_2_action" ) ), 6,
				false ) . ' value="6">' . esc_html__( 'Reject All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The action performed after clicking the button 2 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_notice_button_2_action_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_notice_button_2_url_callback( $args ) {

		$html = '<input maxlength="2048" type="text" id="daextlwcn_cookie_notice_button_2_url" name="daextlwcn_cookie_notice_button_2_url" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_2_url" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The URL where the user will be redirected after clicking the button 2 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_2_url_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_2_url', 'daextlwcn_cookie_notice_button_2_url',
				esc_html__( 'Please enter a valid value in the "Button 2 URL" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_2_url' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_mask_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_notice_mask" name="daextlwcn_cookie_notice_mask" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_mask" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_mask" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Enabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'If you select "Yes" a mask will be generated behind the cookie notice to prevent user interactions with the website.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_notice_mask_validation( $input ) {

		return intval( $input, 10 ) == 1 ? '1' : '0';

	}

	//Style callbacks and validations ----------------------------------------------------------------------------------
	public function cookie_notice_container_background_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_container_background_color" name="daextlwcn_cookie_notice_container_background_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_container_background_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_container_background_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'cookie_notice_container_background_color', 'cookie_notice_container_background_color',
				esc_attr__( 'Please enter a valid color in the "Container Background Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'dale_cookie_notice_container_background_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_container_opacity_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_cookie_notice_container_opacity" name="daextlwcn_cookie_notice_container_opacity" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_container_opacity" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the opacity of the background of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_container_opacity_validation( $input ) {

		return floatval( $input );

	}

	public function cookie_notice_container_border_width_callback( $args ) {

		$html = '<input maxlength="3" type="text" id="daextlwcn_cookie_notice_container_border_width" name="daextlwcn_cookie_notice_container_border_width" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_container_border_width" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the width of the border of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_container_border_width_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_notice_container_border_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_container_border_color" name="daextlwcn_cookie_notice_container_border_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_container_border_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the border of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_container_border_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'cookie_notice_container_border_color', 'cookie_notice_container_border_color',
				esc_attr__( 'Please enter a valid color in the "Container Background Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'dale_cookie_notice_container_border_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_container_border_opacity_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_cookie_notice_container_border_opacity" name="daextlwcn_cookie_notice_container_border_opacity" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_container_border_opacity" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the opacity of the background of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_container_border_opacity_validation( $input ) {

		return floatval( $input );

	}

	public function cookie_notice_container_drop_shadow_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_notice_container_drop_shadow" name="daextlwcn_cookie_notice_container_drop_shadow" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_container_drop_shadow" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_container_drop_shadow" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Enabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'If you select "Enabled" a drop shadow will be added to the cookie notice.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_notice_container_drop_shadow_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_notice_container_drop_shadow_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_container_drop_shadow_color" name="daextlwcn_cookie_notice_container_drop_shadow_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_container_drop_shadow_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the drop shadow displayed behind the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_container_drop_shadow_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_container_drop_shadow_color',
				'daextlwcn_cookie_notice_container_drop_shadow_color',
				esc_attr__( 'Please enter a valid color in the "Container Drop Shadow Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_container_drop_shadow_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_container_position_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_notice_container_position" name="daextlwcn_cookie_notice_container_position" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_container_position" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Top', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_container_position" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Center', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_container_position" ) ), 2,
				false ) . ' value="2">' . esc_html__( 'Bottom', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The position of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_notice_container_position_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_notice_main_message_font_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_main_message_font_color" name="daextlwcn_cookie_notice_main_message_font_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_main_message_font_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the message displayed in the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_main_message_font_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_main_message_font_color',
				'daextlwcn_cookie_notice_main_message_font_color',
				esc_attr__( 'Please enter a valid color in the "Message Font Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_main_message_font_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_main_message_link_font_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_main_message_link_font_color" name="daextlwcn_cookie_notice_main_message_link_font_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_main_message_link_font_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the links included in the message displayed in the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_main_message_link_font_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_main_message_link_font_color',
				'daextlwcn_cookie_notice_main_message_link_font_color',
				esc_attr__( 'Please enter a valid color in the "Message Link Font Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_main_message_link_font_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function headings_font_family_callback( $args ) {

		$html = '<input maxlength="10000" type="text" id="daextlwcn_headings_font_family" name="daextlwcn_headings_font_family" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_headings_font_family" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font family of the headings.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function headings_font_family_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( ! preg_match( $this->shared->font_family_regex, $input ) ) {
			add_settings_error( 'daextlwcn_headings_font_family', 'daextlwcn_headings_font_family',
				esc_html__( 'Please enter a valid value in the "Headings Font Family" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_headings_font_family' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function headings_font_weight_callback( $args ) {

		$html = '<input maxlength="4" type="text" id="daextlwcn_headings_font_weight" name="daextlwcn_headings_font_weight" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_headings_font_weight" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font weight of the headings.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function headings_font_weight_validation( $input ) {

		return intval( $input, 10 );

	}

	public function paragraphs_font_family_callback( $args ) {

		$html = '<input maxlength="10000" type="text" id="daextlwcn_paragraphs_font_family" name="daextlwcn_paragraphs_font_family" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_paragraphs_font_family" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font family of the paragraphs.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function paragraphs_font_family_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( ! preg_match( $this->shared->font_family_regex, $input ) ) {
			add_settings_error( 'daextlwcn_paragraphs_font_family', 'daextlwcn_paragraphs_font_family',
				esc_html__( 'Please enter a valid value in the "Paragraphs Font Family" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_paragraphs_font_family' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function paragraphs_font_weight_callback( $args ) {

		$html = '<input maxlength="4" type="text" id="daextlwcn_paragraphs_font_weight" name="daextlwcn_paragraphs_font_weight" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_paragraphs_font_weight" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font weight of the paragraphs.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function paragraphs_font_weight_validation( $input ) {

		return intval( $input, 10 );

	}

	public function strong_tags_font_weight_callback( $args ) {

		$html = '<input maxlength="4" type="text" id="daextlwcn_strong_tags_font_weight" name="daextlwcn_strong_tags_font_weight" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_strong_tags_font_weight" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font weight of the strong tags.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function strong_tags_font_weight_validation( $input ) {

		return intval( $input, 10 );

	}


	public function buttons_font_family_callback( $args ) {

		$html = '<input maxlength="10000" type="text" id="daextlwcn_buttons_font_family" name="daextlwcn_buttons_font_family" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_buttons_font_family" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font family of the buttons.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function buttons_font_family_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( ! preg_match( $this->shared->font_family_regex, $input ) ) {
			add_settings_error( 'daextlwcn_buttons_font_family', 'daextlwcn_buttons_font_family',
				esc_html__( 'Please enter a valid value in the "Buttons Font Family" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_buttons_font_family' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function buttons_font_weight_callback( $args ) {

		$html = '<input maxlength="4" type="text" id="daextlwcn_buttons_font_weight" name="daextlwcn_buttons_font_weight" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_buttons_font_weight" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font weight of the buttons.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function buttons_font_weight_validation( $input ) {

		return intval( $input, 10 );

	}

	public function buttons_border_radius_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_buttons_border_radius" name="daextlwcn_buttons_border_radius" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_buttons_border_radius" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border radius of the buttons.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function buttons_border_radius_validation( $input ) {

		return intval( $input, 10 );

	}

	public function containers_border_radius_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_containers_border_radius" name="daextlwcn_containers_border_radius" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_containers_border_radius" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border radius of the containers.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function containers_border_radius_validation( $input ) {

		return intval( $input, 10 );

	}


	public function cookie_notice_button_1_background_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_1_background_color" name="daextlwcn_cookie_notice_button_1_background_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_1_background_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the button 1 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_1_background_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_1_background_color',
				'daextlwcn_cookie_notice_button_1_background_color',
				esc_attr__( 'Please enter a valid color in the "Button 1 Background Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_daextlwcn_cookie_notice_button_1_background_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_1_background_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_1_background_color_hover" name="daextlwcn_cookie_notice_button_1_background_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_1_background_color_hover" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the button 1 in hover state of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_1_background_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_1_background_color_hover',
				'daextlwcn_cookie_notice_button_1_background_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 1 Background Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_1_background_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_1_border_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_1_border_color" name="daextlwcn_cookie_notice_button_1_border_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_1_border_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the button 1 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_1_border_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_1_border_color',
				'daextlwcn_cookie_notice_button_1_border_color',
				esc_attr__( 'Please enter a valid color in the "Button 1 Border Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_1_border_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_1_border_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_1_border_color_hover" name="daextlwcn_cookie_notice_button_1_border_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_1_border_color_hover" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the button 1 in hover state of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_1_border_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_1_border_color_hover',
				'daextlwcn_cookie_notice_button_1_border_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 1 Border Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_1_border_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_1_font_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_1_font_color" name="daextlwcn_cookie_notice_button_1_font_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_1_font_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the button 1 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_1_font_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_1_font_color',
				'daextlwcn_cookie_notice_button_1_font_color',
				esc_attr__( 'Please enter a valid color in the "Button 1 Font Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_1_font_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_1_font_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_1_font_color_hover" name="daextlwcn_cookie_notice_button_1_font_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_1_font_color_hover" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the button 1 in hover state of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_1_font_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_1_font_color_hover',
				'daextlwcn_cookie_notice_button_1_font_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 1 Font Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_1_font_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_2_background_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_2_background_color" name="daextlwcn_cookie_notice_button_2_background_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_2_background_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the button 2 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_2_background_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_2_background_color',
				'daextlwcn_cookie_notice_button_2_background_color',
				esc_attr__( 'Please enter a valid color in the "Button 2 Background Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_2_background_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_2_background_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_2_background_color_hover" name="daextlwcn_cookie_notice_button_2_background_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_2_background_color_hover" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the button 2 in hover state of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_2_background_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_2_background_color_hover',
				'daextlwcn_cookie_notice_button_2_background_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 2 Background Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_2_background_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_2_border_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_2_border_color" name="daextlwcn_cookie_notice_button_2_border_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_2_border_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the button 2 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_2_border_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_2_border_color',
				'daextlwcn_cookie_notice_button_2_border_color',
				esc_attr__( 'Please enter a valid color in the "Button 2 Border Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_2_border_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_2_border_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_2_border_color_hover" name="daextlwcn_cookie_notice_button_2_border_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_2_border_color_hover" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the button 2 in hover state of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_2_border_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_2_border_color_hover',
				'daextlwcn_cookie_notice_button_2_border_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 2 Border Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_2_border_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_2_font_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_2_font_color" name="daextlwcn_cookie_notice_button_2_font_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_2_font_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the button 2 of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_2_font_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_2_font_color',
				'daextlwcn_cookie_notice_button_2_font_color',
				esc_attr__( 'Please enter a valid color in the "Button 2 Font Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_2_font_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_2_font_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_2_font_color_hover" name="daextlwcn_cookie_notice_button_2_font_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_2_font_color_hover" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the button 2 in hover state of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_2_font_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_2_font_color_hover',
				'daextlwcn_cookie_notice_button_2_font_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 2 Font Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_2_font_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_dismiss_action_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_notice_button_dismiss_action" name="daextlwcn_cookie_notice_button_dismiss_action" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_dismiss_action" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_dismiss_action" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Cookie Settings', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_dismiss_action" ) ), 2,
				false ) . ' value="2">' . esc_html__( 'Accept Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_dismiss_action" ) ), 3,
				false ) . ' value="3">' . esc_html__( 'Close Notice', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_dismiss_action" ) ), 4,
				false ) . ' value="4">' . esc_html__( 'Redirect to URL', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_dismiss_action" ) ), 5,
				false ) . ' value="5">' . esc_html__( 'Accept All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_button_dismiss_action" ) ), 6,
				false ) . ' value="6">' . esc_html__( 'Reject All Cookies', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The action performed after clicking the dismiss button of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_notice_button_dismiss_action_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_notice_button_dismiss_url_callback( $args ) {

		$html = '<input maxlength="2048" type="text" id="daextlwcn_cookie_notice_button_dismiss_url" name="daextlwcn_cookie_notice_button_dismiss_url" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_dismiss_url" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The URL where the user will be redirected after clicking the dismiss button. Please note that this option will be used only if the "Button Dismiss Action" option is set to "Redirect to URL"', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_dismiss_url_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_dismiss_url',
				'daextlwcn_cookie_notice_button_dismiss_url',
				esc_html__( 'Please enter a valid value in the "Button Dismiss URL" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_dismiss_url' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_button_dismiss_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_button_dismiss_color" name="daextlwcn_cookie_notice_button_dismiss_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_button_dismiss_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the dismiss button of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_button_dismiss_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_button_dismiss_color',
				'daextlwcn_cookie_notice_button_dismiss_color',
				esc_attr__( 'Please enter a valid color in the "Button Dismiss Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_button_dismiss_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_container_width_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_cookie_notice_container_width" name="daextlwcn_cookie_notice_container_width" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_container_width" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the width of the wrapper that includes the content of the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_container_width_validation( $input ) {

		return intval( $input, 10 );

	}

	public function enable_mask_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_enable_mask" name="daextlwcn_enable_mask" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_enable_mask" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'If you select "Yes" a mask will be generated behind the cookie notice to prevent user interactions with the website.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function enable_mask_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 2000 ) {
			add_settings_error( 'daextlwcn_enable_mask', 'daextlwcn_enable_mask',
				esc_html__( 'Please enter a valid value in the "Mask Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_enable_mask' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_mask_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_notice_mask_color" name="daextlwcn_cookie_notice_mask_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_mask_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the mask displayed behind the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_mask_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_notice_mask_color', 'daextlwcn_cookie_notice_mask_color',
				esc_attr__( 'Please enter a valid color in the "Mask Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_notice_mask_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_notice_mask_opacity_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_cookie_notice_mask_opacity" name="daextlwcn_cookie_notice_mask_opacity" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_notice_mask_opacity" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the opacity of the mask displayed behind the cookie notice.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_notice_mask_opacity_validation( $input ) {

		return floatval( $input );

	}

	public function cookie_notice_shake_effect_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_notice_shake_effect" name="daextlwcn_cookie_notice_shake_effect" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_shake_effect" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_notice_shake_effect" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Enabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'If you select "Enabled" a shake effect will be applied on the cookie notice when the user clicks on the mask.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_notice_shake_effect_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_settings_container_background_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_container_background_color" name="daextlwcn_cookie_settings_container_background_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_container_background_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_container_background_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_container_background_color',
				'daextlwcn_cookie_settings_container_background_color',
				esc_attr__( 'Please enter a valid color in the "Container Background Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_container_background_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_container_opacity_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_cookie_settings_container_opacity" name="daextlwcn_cookie_settings_container_opacity" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_container_opacity" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the opacity of the background of the cookie settings.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_container_opacity_validation( $input ) {

		return floatval( $input );

	}

	public function cookie_settings_container_border_width_callback( $args ) {

		$html = '<input maxlength="3" type="text" id="daextlwcn_cookie_settings_container_border_width" name="daextlwcn_cookie_settings_container_border_width" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_container_border_width" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the width of the border of the cookie settings.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_container_border_width_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_settings_container_border_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_container_border_color" name="daextlwcn_cookie_settings_container_border_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_container_border_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_container_border_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_container_border_color',
				'daextlwcn_cookie_settings_container_border_color',
				esc_attr__( 'Please enter a valid color in the "Container Border Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_container_border_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_container_border_opacity_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_cookie_settings_container_border_opacity" name="daextlwcn_cookie_settings_container_border_opacity" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_container_border_opacity" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the opacity of the cookie settings modal window border.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_container_border_opacity_validation( $input ) {

		return floatval( $input );

	}

	public function cookie_settings_container_highlight_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_container_highlight_color" name="daextlwcn_cookie_settings_container_highlight_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_container_highlight_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the highlight color of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_container_drop_shadow_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_settings_container_drop_shadow" name="daextlwcn_cookie_settings_container_drop_shadow" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_container_drop_shadow" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_settings_container_drop_shadow" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Enabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'If you select "Enabled" a drop shadow will be added to the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_settings_container_drop_shadow_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_settings_container_drop_shadow_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_container_drop_shadow_color" name="daextlwcn_cookie_settings_container_drop_shadow_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_container_drop_shadow_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the drop shadow displayed behind the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_container_drop_shadow_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_container_drop_shadow_color',
				'daextlwcn_cookie_settings_container_drop_shadow_color',
				esc_attr__( 'Please enter a valid color in the "Container Drop Shadow Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_container_drop_shadow_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_container_highlight_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_container_highlight_color',
				'daextlwcn_cookie_settings_container_highlight_color',
				esc_attr__( 'Please enter a valid color in the "Container Highlight Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_container_highlight_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_mask_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_mask_color" name="daextlwcn_cookie_settings_mask_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_mask_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the color of the mask displayed behind the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_mask_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_mask_color', 'daextlwcn_cookie_settings_mask_color',
				esc_attr__( 'Please enter a valid color in the "Mask Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_mask_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_mask_opacity_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_cookie_settings_mask_opacity" name="daextlwcn_cookie_settings_mask_opacity" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_mask_opacity" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the opacity of the mask displayed behind the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_mask_opacity_validation( $input ) {

		return floatval( $input );

	}

	public function revisit_consent_button_enable_callback( $args ) {

		$html = '<select id="daextlwcn_revisit_consent_button_enable" name="daextlwcn_revisit_consent_button_enable" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_revisit_consent_button_enable" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'No', 'daextlwcnf' ) . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_revisit_consent_button_enable" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Yes', 'daextlwcnf' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Whether to enable or not the revisit consent button. The revisit consent button allows visitors to revoke their prior preferences.',
				'daextlwcnf' ) . '"></div>';

		echo $html;

	}

	public function revisit_consent_button_enable_validation( $input ) {

		return intval( $input, 10 ) == 1 ? '1' : '0';

	}

	public function revisit_consent_button_tooltip_text_callback( $args ) {

		$html = '<input maxlength="1000" type="text" id="daextlwcn_revisit_consent_button_tooltip_text" name="daextlwcn_revisit_consent_button_tooltip_text" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_revisit_consent_button_tooltip_text" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The tooltip of the revisit content button.',
				'daextlwcnf' ) . '"></div>';
		echo $html;

	}

	public function revisit_consent_button_tooltip_text_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_revisit_consent_button_tooltip_text', 'daextlwcn_revisit_consent_button_tooltip_text',
				esc_html__( 'Please enter a valid value in the "Tooltip Text" option.', 'daextlwcnf' ) );
			$output = get_option( 'daextlwcn_revisit_consent_button_tooltip_text' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function revisit_consent_button_position_callback( $args ) {

		$html = '<select id="daextlwcn_revisit_consent_button_position" name="daextlwcn_revisit_consent_button_position" class="daext-display-none">';
		$html .= '<option ' . selected( get_option( "daextlwcn_revisit_consent_button_position" ), 'left',
				false ) . ' value="left">' . esc_html__( 'Left', 'daextlwcnf' ) . '</option>';
		$html .= '<option ' . selected( get_option( "daextlwcn_revisit_consent_button_position" ), 'right',
				false ) . ' value="right">' . esc_html__( 'Right', 'daextlwcnf' ) . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The position of the revisit consent button.',
				'daextlwcnf' ) . '"></div>';

		echo $html;

	}

	public function revisit_consent_button_position_validation( $input ) {

		return $input == 'left' ? 'left' : 'right';

	}

	public function revisit_consent_button_background_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_revisit_consent_button_background_color" name="daextlwcn_revisit_consent_button_background_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_revisit_consent_button_background_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The background color of the revisit consent button.',
				'daextlwcnf' ) . '"></div>';
		echo $html;

	}

	public function revisit_consent_button_background_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_revisit_consent_button_background_color',
				'daextlwcn_revisit_consent_button_background_color',
				esc_attr__( 'Please enter a valid color in the "Background Color" option.', 'daextlwcnf' ) );
			$output = get_option( 'daextlwcn_daextlwcn_revisit_consent_button_background_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function revisit_consent_button_icon_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_revisit_consent_button_icon_color" name="daextlwcn_revisit_consent_button_icon_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_revisit_consent_button_icon_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The icon color of the revisit consent button.',
				'daextlwcnf' ) . '"></div>';
		echo $html;

	}

	public function revisit_consent_button_icon_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_revisit_consent_button_icon_color',
				'daextlwcn_revisit_consent_button_icon_color',
				esc_attr__( 'Please enter a valid color in the "Icon Color" option.', 'daextlwcnf' ) );
			$output = get_option( 'daextlwcn_daextlwcn_revisit_consent_button_icon_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_1_background_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_1_background_color" name="daextlwcn_cookie_settings_button_1_background_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_1_background_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the button 1 of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_1_background_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_1_background_color',
				'daextlwcn_cookie_settings_button_1_background_color',
				esc_attr__( 'Please enter a valid color in the "Button 1 Background Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_1_background_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_1_background_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_1_background_color_hover" name="daextlwcn_cookie_settings_button_1_background_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_1_background_color_hover" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the button 1 in hover status of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_1_background_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_1_background_color_hover',
				'daextlwcn_cookie_settings_button_1_background_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 1 Background Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_1_background_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_1_border_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_1_border_color" name="daextlwcn_cookie_settings_button_1_border_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_1_border_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the button 1 of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_1_border_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_1_border_color',
				'daextlwcn_cookie_settings_button_1_border_color',
				esc_attr__( 'Please enter a valid color in the "Button 1 Border Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_1_border_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_1_border_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_1_border_color_hover" name="daextlwcn_cookie_settings_button_1_border_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_1_border_color_hover" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the button 1 in hover state of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_1_border_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_1_border_color_hover',
				'daextlwcn_cookie_settings_button_1_border_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 1 Border Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_1_border_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_1_font_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_1_font_color" name="daextlwcn_cookie_settings_button_1_font_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_1_font_color" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the button 1 of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_1_font_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_1_font_color',
				'daextlwcn_cookie_settings_button_1_font_color',
				esc_attr__( 'Please enter a valid color in the "Button 1 Font Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_1_font_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_1_font_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_1_font_color_hover" name="daextlwcn_cookie_settings_button_1_font_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_1_font_color_hover" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the button 1 in hover state of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_1_font_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_1_font_color_hover',
				'daextlwcn_cookie_settings_button_1_font_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 1 Font Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_1_font_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_2_background_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_2_background_color" name="daextlwcn_cookie_settings_button_2_background_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_2_background_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the button 2 of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_2_background_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_2_background_color',
				'daextlwcn_cookie_settings_button_2_background_color',
				esc_attr__( 'Please enter a valid color in the "Button 2 Background Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_2_background_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_2_background_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_2_background_color_hover" name="daextlwcn_cookie_settings_button_2_background_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_2_background_color_hover" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the background color of the button 2 in hover state of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_2_background_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_2_background_color_hover',
				'daextlwcn_cookie_settings_button_2_background_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 2 Background Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_2_background_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_2_border_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_2_border_color" name="daextlwcn_cookie_settings_button_2_border_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_2_border_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the button 2 of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_2_border_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_2_border_color',
				'daextlwcn_cookie_settings_button_2_border_color',
				esc_attr__( 'Please enter a valid color in the "Button 2 Border Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_2_border_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_2_border_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_2_border_color_hover" name="daextlwcn_cookie_settings_button_2_border_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_2_border_color_hover" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the border color of the button 2 in hover state of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_2_border_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_2_border_color_hover',
				'daextlwcn_cookie_settings_button_2_border_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 2 Border Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_2_border_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_headings_font_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_headings_font_color" name="daextlwcn_cookie_settings_headings_font_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_headings_font_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the headings of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_headings_font_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_headings_font_color',
				'daextlwcn_cookie_settings_headings_font_color',
				esc_attr__( 'Please enter a valid color in the "Headings Font Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_headings_font_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_paragraphs_font_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_paragraphs_font_color" name="daextlwcn_cookie_settings_paragraphs_font_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_paragraphs_font_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the paragraphs of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_paragraphs_font_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_paragraphs_font_color',
				'daextlwcn_cookie_settings_paragraphs_font_color',
				esc_attr__( 'Please enter a valid color in the "Paragraphs Font Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_paragraphs_font_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_links_font_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_links_font_color" name="daextlwcn_cookie_settings_links_font_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_links_font_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the links of the cookie settings modal window.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_links_font_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_links_font_color',
				'daextlwcn_cookie_settings_links_font_color',
				esc_attr__( 'Please enter a valid color in the "Links Font Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_links_font_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_2_font_color_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_2_font_color" name="daextlwcn_cookie_settings_button_2_font_color" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_2_font_color" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the button 2 of the cookie settings.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_2_font_color_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_2_font_color',
				'daextlwcn_cookie_settings_button_2_font_color',
				esc_attr__( 'Please enter a valid color in the "Button 2 Font Color" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_2_font_color' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function cookie_settings_button_2_font_color_hover_callback( $args ) {

		$html = '<input class="wp-color-picker" maxlength="7" type="text" id="daextlwcn_cookie_settings_button_2_font_color_hover" name="daextlwcn_cookie_settings_button_2_font_color_hover" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_cookie_settings_button_2_font_color_hover" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines the font color of the button 2 in hover state of the cookie settings.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function cookie_settings_button_2_font_color_hover_validation( $input ) {

		if ( ! preg_match( $this->shared->hex_rgb_regex, $input ) ) {
			add_settings_error( 'daextlwcn_cookie_settings_button_2_font_color_hover',
				'daextlwcn_cookie_settings_button_2_font_color_hover',
				esc_attr__( 'Please enter a valid color in the "Button 2 Font Color Hover" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_cookie_settings_button_2_font_color_hover' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function responsive_breakpoint_callback( $args ) {

		$html = '<input maxlength="3" type="text" id="daextlwcn_responsive_breakpoint" name="daextlwcn_responsive_breakpoint" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_responsive_breakpoint" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'When the browser viewport width goes below this value the mobile version of the cookie notice and cookie settings modal window will be used.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function responsive_breakpoint_validation( $input ) {

		return intval( $input, 10 );

	}

	public function cookie_table_columns_callback( $args ) {

		$html                 = '<select id="daextlwcn_cookie_table_columns" name="daextlwcn_cookie_table_columns[]" class="daext-display-none" multiple="multiple">';
		$columns              = [
			'name'             => __( 'Name', 'lightweight-cookie-notice'),
			'expiration'       => __( 'Expiration', 'lightweight-cookie-notice'),
			'purpose'          => __( 'Purpose', 'lightweight-cookie-notice'),
			'provider'         => __( 'Provider', 'lightweight-cookie-notice'),
			'domain'           => __( 'Domain', 'lightweight-cookie-notice'),
			'type'             => __( 'Type', 'lightweight-cookie-notice'),
			'sensitivity'      => __( 'Sensitivity', 'lightweight-cookie-notice'),
			'security'         => __( 'Security', 'lightweight-cookie-notice'),
			'more-information' => __( 'More Information', 'lightweight-cookie-notice'),
		];
		$cookie_table_columns = get_option( "daextlwcn_cookie_table_columns" );
		foreach ( $columns as $key => $value ) {
			$html .= '<option value="' . $key . '" ' . $this->shared->selected_array( $cookie_table_columns,
					$key ) . '>' . esc_html( $value ) . '</option>';
		}
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The columns included in the table used to display the cookies.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_table_columns_validation( $input ) {

		if ( is_array( $input ) ) {
			return $input;
		} else {
			return '';
		}

	}

	//Geolocation callbacks and validations ----------------------------------------------------------------------------------
	public function enable_geolocation_callback( $args ) {

		$html = '<select id="daextlwcn_enable_geolocation" name="daextlwcn_enable_geolocation" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_enable_geolocation" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_enable_geolocation" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Enabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'If you select "Enabled" the cookie notice will be displayed only to the users located in the countries defined with the "Geolocation Locale" option.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function enable_geolocation_validation( $input ) {

		return intval( $input, 10 );

	}

	public function geolocation_behavior_callback( $args ) {

		$html = '<select id="daextlwcn_geolocation_behavior" name="daextlwcn_geolocation_behavior" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_geolocation_behavior" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disable cookie notice', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_geolocation_behavior" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Disable cookie notice and enable all cookie categories', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The behavior applied when the user is not located in the selected geographic targets.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function geolocation_behavior_validation( $input ) {

		return intval( $input, 10 );

	}

	public function geolocation_locale_callback( $args ) {

		$html               = '<select id="daextlwcn_geolocation_locale" name="daextlwcn_geolocation_locale[]" class="daext-display-none" multiple="multiple">';
		$array_locale       = get_option( 'daextlwcn_locale' );
		$geolocation_locale = get_option( "daextlwcn_geolocation_locale" );
		foreach ( $array_locale as $key => $value ) {
			$html .= '<option value="' . $value . '" ' . $this->shared->selected_array( $geolocation_locale,
					$value ) . '>' . esc_html( $key ) . '</option>';
		}
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The list of countries where the cookie notice should be displayed.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function geolocation_subdivision_callback( $args ) {

		$html               = '<select id="daextlwcn_geolocation_subdivision" name="daextlwcn_geolocation_subdivision[]" class="daext-display-none" multiple="multiple">';
		$array_subdivision       = [
			'US-AL' => 'Alabama	State',
			'US-AK' => 'Alaska	State',
			'US-AZ' => 'Arizona	State',
			'US-AR' => 'Arkansas	State',
			'US-CA' => 'California	State',
			'US-CO' => 'Colorado	State',
			'US-CT' => 'Connecticut	State',
			'US-DE' => 'Delaware	State',
			'US-FL' => 'Florida	State',
			'US-GA' => 'Georgia	State',
			'US-HI' => 'Hawaii	State',
			'US-ID' => 'Idaho	State',
			'US-IL' => 'Illinois	State',
			'US-IN' => 'Indiana	State',
			'US-IA' => 'Iowa	State',
			'US-KS' => 'Kansas	State',
			'US-KY' => 'Kentucky	State',
			'US-LA' => 'Louisiana	State',
			'US-ME' => 'Maine	State',
			'US-MD' => 'Maryland	State',
			'US-MA' => 'Massachusetts	State',
			'US-MI' => 'Michigan	State',
			'US-MN' => 'Minnesota	State',
			'US-MS' => 'Mississippi	State',
			'US-MO' => 'Missouri	State',
			'US-MT' => 'Montana	State',
			'US-NE' => 'Nebraska	State',
			'US-NV' => 'Nevada	State',
			'US-NH' => 'New Hampshire	State',
			'US-NJ' => 'New Jersey	State',
			'US-NM' => 'New Mexico	State',
			'US-NY' => 'New York	State',
			'US-NC' => 'North Carolina	State',
			'US-ND' => 'North Dakota	State',
			'US-OH' => 'Ohio	State',
			'US-OK' => 'Oklahoma	State',
			'US-OR' => 'Oregon	State',
			'US-PA' => 'Pennsylvania	State',
			'US-RI' => 'Rhode Island	State',
			'US-SC' => 'South Carolina	State',
			'US-SD' => 'South Dakota	State',
			'US-TN' => 'Tennessee	State',
			'US-TX' => 'Texas	State',
			'US-UT' => 'Utah	State',
			'US-VT' => 'Vermont	State',
			'US-VA' => 'Virginia	State',
			'US-WA' => 'Washington	State',
			'US-WV' => 'West Virginia	State',
			'US-WI' => 'Wisconsin	State',
			'US-WY' => 'Wyoming	State',
			'US-DC' => 'District of Columbia	District',
			'US-AS' => 'American Samoa	Outlying area',
			'US-GU' => 'Guam	Outlying area',
			'US-MP' => 'Northern Mariana Islands	Outlying area',
			'US-PR' => 'Puerto Rico	Outlying area',
			'US-UM' => 'United States Minor Outlying Islands	Outlying area',
			'US-VI' => 'Virgin Islands, U.S.	Outlying area',
		];
		$geolocation_subdivision = get_option( "daextlwcn_geolocation_subdivision" );
		foreach ( $array_subdivision as $key => $value ) {
			$html .= '<option value="' . $key . '" ' . $this->shared->selected_array( $geolocation_subdivision,
					$key ) . '>' . esc_html( $key ) . ' - ' . esc_html($value ) . '</option>';
		}
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The list of subdivisions where the cookie notice should be displayed. Note that this option is used only if the "Geolocation Service" option is set the "MaxMind GeoLite2".', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function geolocation_locale_validation( $input ) {

		if ( is_array( $input ) ) {
			return $input;
		} else {
			return '';
		}

	}

	public function geolocation_service_callback( $args ) {

		$html = '<select id="daextlwcn_geolocation_service" name="daextlwcn_geolocation_service" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_geolocation_service" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'HostIP.info', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_geolocation_service" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'MaxMind GeoLite2', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The geolocation service used to detect the user location.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function geolocation_service_validation( $input ) {

		return intval( $input, 10 );

	}

	public function maxmind_license_key_callback( $args ) {

		$html = '<input maxlength="100" type="text" id="daextlwcn_maxmind_license_key" name="daextlwcn_maxmind_license_key" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_maxmind_license_key" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The license key provided by MaxMind used by this plugin to automate the database download.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function maxmind_license_key_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_maxmind_license_key', 'daextlwcn_maxmind_license_key',
				esc_html__( 'Please enter a valid value in the "MaxMind License Key" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_maxmind_license_key' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function maxmind_database_file_path_callback( $args ) {

		$html = '<input maxlength="2000" type="text" id="daextlwcn_maxmind_database_file_path" name="daextlwcn_maxmind_database_file_path" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_maxmind_database_file_path" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The file path where the database provided by MaxMind should be stored.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function maxmind_database_file_path_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 2000 ) {
			add_settings_error( 'daextlwcn_maxmind_database_file_path', 'daextlwcn_maxmind_database_file_path',
				esc_html__( 'Please enter a valid value in the "MaxMind Database File Path" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_maxmind_database_file_path' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function maxmind_database_city_file_path_callback( $args ) {

		$html = '<input maxlength="2000" type="text" id="daextlwcn_maxmind_database_city_file_path" name="daextlwcn_maxmind_database_city_file_path" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_maxmind_database_city_file_path" ),
				20 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The file path where the database city provided by MaxMind should be stored.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function maxmind_database_city_file_path_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 2000 ) {
			add_settings_error( 'daextlwcn_maxmind_database_city_file_path', 'daextlwcn_maxmind_database_city_file_path',
				esc_html__( 'Please enter a valid value in the "MaxMind Database City File Path" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_maxmind_database_city_file_path' );
		} else {
			$output = $input;
		}

		return $output;

	}

	//Capabilities callbacks and validations ---------------------------------------------------------------------------
	public function capability_menu_sections_callback( $args ) {

		$html = '<input autocomplete="off" type="text" id="daextlwcn-capability-menu-player-award-types" name="daextlwcn_capability_menu_sections" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_capability_menu_sections" ) ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The capability required to get access on the "Sections" menu.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function capability_menu_sections_validation( $input ) {

		if ( ! preg_match( $this->shared->regex_capability, $input ) ) {
			add_settings_error( 'daextlwcn_capability_menu_sections', 'daextlwcn_capability_menu_sections',
				__( 'Please enter a valid capability in the "Sections Menu" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_capability_menu_sections' );
		} else {
			$output = $input;
		}

		return trim( $output );

	}

	public function capability_menu_categories_callback( $args ) {

		$html = '<input autocomplete="off" type="text" id="daextlwcn-capability-menu-player-award-types" name="daextlwcn_capability_menu_categories" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_capability_menu_categories" ) ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The capability required to get access on the "Categories" menu.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function capability_menu_categories_validation( $input ) {

		if ( ! preg_match( $this->shared->regex_capability, $input ) ) {
			add_settings_error( 'daextlwcn_capability_menu_categories', 'daextlwcn_capability_menu_categories',
				__( 'Please enter a valid capability in the "Categories Menu" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_capability_menu_categories' );
		} else {
			$output = $input;
		}

		return trim( $output );

	}

	public function capability_menu_cookies_callback( $args ) {

		$html = '<input autocomplete="off" type="text" id="daextlwcn-capability-menu-player-award-types" name="daextlwcn_capability_menu_cookies" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_capability_menu_cookies" ) ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The capability required to get access on the "Cookies" menu.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function capability_menu_cookies_validation( $input ) {

		if ( ! preg_match( $this->shared->regex_capability, $input ) ) {
			add_settings_error( 'daextlwcn_capability_menu_cookies', 'daextlwcn_capability_menu_cookies',
				__( 'Please enter a valid capability in the "Cookies Menu" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_capability_menu_cookies' );
		} else {
			$output = $input;
		}

		return trim( $output );

	}

	public function capability_menu_import_callback( $args ) {

		$html = '<input autocomplete="off" type="text" id="daextlwcn-capability-menu-player-award-types" name="daextlwcn_capability_menu_import" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_capability_menu_import" ) ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The capability required to get access on the "Import" menu.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function capability_menu_import_validation( $input ) {

		if ( ! preg_match( $this->shared->regex_capability, $input ) ) {
			add_settings_error( 'daextlwcn_capability_menu_import', 'daextlwcn_capability_menu_import',
				__( 'Please enter a valid capability in the "Import Menu" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_capability_menu_import' );
		} else {
			$output = $input;
		}

		return trim( $output );

	}

	public function capability_menu_export_callback( $args ) {

		$html = '<input autocomplete="off" type="text" id="daextlwcn-capability-menu-player-award-types" name="daextlwcn_capability_menu_export" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_capability_menu_export" ) ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The capability required to get access on the "Export" menu.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function capability_menu_export_validation( $input ) {

		if ( ! preg_match( $this->shared->regex_capability, $input ) ) {
			add_settings_error( 'daextlwcn_capability_menu_export', 'daextlwcn_capability_menu_export',
				__( 'Please enter a valid capability in the "Export Menu" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_capability_menu_export' );
		} else {
			$output = $input;
		}

		return trim( $output );

	}

	public function capability_menu_maintenance_callback( $args ) {

		$html = '<input autocomplete="off" type="text" id="daextlwcn-capability-menu-player-award-types" name="daextlwcn_capability_menu_maintenance" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_capability_menu_maintenance" ) ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The capability required to get access on the "Maintenance" menu.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function capability_menu_maintenance_validation( $input ) {

		if ( ! preg_match( $this->shared->regex_capability, $input ) ) {
			add_settings_error( 'daextlwcn_capability_menu_maintenance', 'daextlwcn_capability_menu_maintenance',
				__( 'Please enter a valid capability in the "Maintenance Menu" option.', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_capability_menu_maintenance' );
		} else {
			$output = $input;
		}

		return trim( $output );

	}

	//Advanced callbacks and validations -------------------------------------------------------------------------------
	public function assets_mode_callback( $args ) {

		$html = '<select id="daextlwcn_assets_mode" name="daextlwcn_assets_mode" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_assets_mode" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Development', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_assets_mode" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Production', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'With "Development" selected the development version of the JavaScript files used by the plugin will be loaded on the front-end. With "Production" selected the minified version of the JavaScript file used by the plugin will be loaded on the front-end.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function assets_mode_validation( $input ) {

		return intval( $input, 10 ) == 1 ? '1' : '0';

	}

	public function test_mode_callback( $args ) {

		$html = '<select id="daextlwcn_test_mode" name="daextlwcn_test_mode" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_test_mode" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'No', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_test_mode" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Yes', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'With the test mode enabled the cookie notice will be applied in the front-end only if the user that is requesting the page is the website administrator.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function test_mode_validation( $input ) {

		return intval( $input, 10 ) == 1 ? '1' : '0';

	}

	public function cookie_expiration_callback( $args ) {

		$html = '<select id="daextlwcn_cookie_expiration" name="daextlwcn_cookie_expiration" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_expiration" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Unlimited', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_expiration" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'One Hour', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_expiration" ) ), 2,
				false ) . ' value="2">' . esc_html__( 'One Day', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_expiration" ) ), 3,
				false ) . ' value="3">' . esc_html__( 'One Week', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_expiration" ) ), 4,
				false ) . ' value="4">' . esc_html__( 'One Month', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_expiration" ) ), 5,
				false ) . ' value="5">' . esc_html__( 'Three Months', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_expiration" ) ), 6,
				false ) . ' value="6">' . esc_html__( 'Six Months', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_cookie_expiration" ) ), 7,
				false ) . ' value="7">' . esc_html__( 'One Year', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'The amount of time the cookies used to store the acceptance status and the accepted categories should be stored.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function cookie_expiration_validation( $input ) {

		return intval( $input, 10 );

	}

	public function reload_page_callback( $args ) {

		$html = '<select id="daextlwcn_reload_page" name="daextlwcn_reload_page" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_reload_page" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'No', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_reload_page" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Yes', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'With this option enabled when the user accepts the cookies the page is reloaded.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function reload_page_validation( $input ) {

		return intval( $input, 10 ) == 1 ? '1' : '0';

	}

	public function category_acceptance_callback( $args ) {

		$html = '<select id="daextlwcn_category_acceptance" name="daextlwcn_category_acceptance" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_category_acceptance" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'Disabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_category_acceptance" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Enabled', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'If you select "Enabled" the category acceptance will be recorded.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function category_acceptance_validation( $input ) {

		return intval( $input, 10 );

	}

	public function transient_expiration_callback( $args ) {

		$html = '<input maxlength="7" type="text" id="daextlwcn_transient_expiration" name="daextlwcn_transient_expiration" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_transient_expiration" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Enter the transient expiration in seconds or set 0 to not use a transient.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function transient_expiration_validation( $input ) {

		return intval( $input, 10 );

	}

	public function google_font_url_callback( $args ) {

		$html = '<input maxlength="1000" type="text" id="daextlwcn_google_font_url" name="daextlwcn_google_font_url" class="regular-text" value="' . esc_attr( get_option( "daextlwcn_google_font_url" ),
				10 ) . '" />';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'Load one or more Google Fonts in the front-end of your website by entering the embed code in this option.', 'lightweight-cookie-notice') . '"></div>';
		echo $html;

	}

	public function google_font_url_validation( $input ) {

		$input = sanitize_text_field( $input );

		if ( strlen( $input ) > 1000 ) {
			add_settings_error( 'daextlwcn_google_font_url', 'daextlwcn_google_font_url',
				esc_html__( 'Google Font URL', 'lightweight-cookie-notice') );
			$output = get_option( 'daextlwcn_google_font_url' );
		} else {
			$output = $input;
		}

		return $output;

	}

	public function force_css_specificity_callback( $args ) {

		$html = '<select id="daextlwcn_force_css_specificity" name="daextlwcn_force_css_specificity" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_force_css_specificity" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'No', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_force_css_specificity" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Yes', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'If you select "Yes" the CSS specificity will be force with the "!important" rule.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function force_css_specificity_validation( $input ) {

		return intval( $input, 10 );

	}

	public function compress_output_callback( $args ) {

		$html = '<select id="daextlwcn_compress_output" name="daextlwcn_compress_output" class="daext-display-none">';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_compress_output" ) ), 0,
				false ) . ' value="0">' . esc_html__( 'No', 'lightweight-cookie-notice') . '</option>';
		$html .= '<option ' . selected( intval( get_option( "daextlwcn_compress_output" ) ), 1,
				false ) . ' value="1">' . esc_html__( 'Yes', 'lightweight-cookie-notice') . '</option>';
		$html .= '</select>';
		$html .= '<div class="help-icon" title="' . esc_attr__( 'This option determines if the JavaScript code used to initialize the plugin in the front-end should be compressed.', 'lightweight-cookie-notice') . '"></div>';

		echo $html;

	}

	public function compress_output_validation( $input ) {

		return intval( $input, 10 );

	}

}